'use strict';
var appVersion = "0.0.0";

var noAds = JSON.parse(window.localStorage.getItem('noAds')) || false;

var ADSMODULE = (function () {
  var my = {},
      noAds = JSON.parse(window.localStorage.getItem('noAds')) || false,
      noAdsTime = JSON.parse(window.localStorage.getItem('noAdsTime')) || 0,
      clan = JSON.parse(window.localStorage.getItem('noAdsClan')) || false;

  function checkTimeNoAds() {
    var now = Date.now() / 1000 | 0;
    if(now < noAdsTime){
      return true;
    }
    return false;
  }
  // Set by purchase or by clan buy option
  my.setNoAds = function(value){
    noAds = value;
    window.localStorage.setItem('noAds', value);
  };
  // Set the time after user has watched a video
  my.setNoAdsTime = function(){
    var _data = Date.now() / 1000 | 0;
    _data = _data + 86400;
    noAdsTime = _data;
    window.localStorage.setItem('noAdsTime', noAdsTime);
  };
  // Set if clan d
  my.setNoAdsClan = function(value){
    clan = value;
    window.localStorage.setItem('noAdsClan', value);
  };
  my.getNoAdsClan = function(){
    return clan;
  };
  my.getNoAds = function () {
    if(noAds){ // Ads are disabled by purchase or by hole clan
      return true;
    }
    if(checkTimeNoAds()) { // Ads disabled by watching a video
      return true;
    }
    return false;
  };

  return my;
}());



/*
 * app.js
 *
 * point of entry for the app
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('AuthenticateMe', [
  'ionic',
  'controllers.main',
  'controllers.auth',
  'controllers.profile',
  'controllers.users',
  'controllers.clan',
  'controllers.contact',
  'controllers.news',
  'controllers.faq',
  'controllers.videos',
  'controllers.war.archive',
  'controllers.war.archive.detail',
  'controllers.war.archive.info',
  'controllers.war',
  'controllers.war.stats',
  'controllers.war.info',
  'controllers.suggest.suggest',
  'controllers.suggest.view',
  'controllers.clan.pushMsg',
  'controllers.clan.edit',
  'controllers.clan.showMsg',
  'controllers.clan.chat',
  'controllers.clan.other',
  'controllers.clan.player',
  'controllers.army',
  'controllers.troop',
  'controllers.users.profile',
  'services.common.constants',
  'services.common.auth',
  'components.http-auth-interceptor',
  'ngCordova',
  'pascalprecht.translate',
  'ngCookies',
  'admobModule'
]).filter('range', function() {
    return function(input, total,start,multiply) {
      if(typeof start === 'undefined') start = 0;
      if(typeof multiply === 'undefined') multiply = 1;
        total = parseInt(total);
        for (var i=start; i<total+start; i= i + multiply)
            input.push(i);
        return input;
    };
})

.run(function($ionicPlatform, AuthService, Constants, $state, $rootScope,$http,$cordovaNetwork,$ionicLoading, $cordovaPush, $timeout, admobSvc) {

  
      // You could also call admobSvc.createBannerView(options);


      // Handle events:
      $rootScope.$on(admobSvc.events.onAdOpened, function onAdOpened(evt, e) {
        console.log('adOpened: type of ad:' + e.adType);
      });

  $ionicPlatform.ready(function() {
    // AddMOB problem fix
    // var AdLoaded = false;
    // var BlackHidden = false;

    // document.addEventListener('onAdLoaded', function (e) { AdLoaded = true; });
    // window.addEventListener('native.keyboardhide', keyboardHideHandler);
    // function keyboardHideHandler(e) {
    //     if (AdLoaded && !BlackHidden) {

    //             AdMob.showBanner(AdMob.AD_POSITION.BOTTOM_CENTER);
    //             BlackHidden = true;

    //     }
    // }
    // 
    
    // AdColony Setup
      var appId = "app815aed8117264e93b7";
      var fullScreenAdZoneId = "REPLACE_THIS_WITH_YOUR_FULL_SCREEN_AD_ZONE_ID";
      var rewardedVideoAdZoneId = "vz89d2cf99a282400ca0";
      
      var appId;
      var fullScreenAdZoneId;
      var rewardedVideoAdZoneId;
      //android
      if (navigator.userAgent.match(/Android/i)) {
          appId = "app815aed8117264e93b7";
          fullScreenAdZoneId = "REPLACE_THIS_WITH_YOUR_FULL_SCREEN_AD_ZONE_ID";
          rewardedVideoAdZoneId = "vz89d2cf99a282400ca0";
      }
      //ios
      else if (navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i)) {
          appId = "appc1065790678048afbd";
          fullScreenAdZoneId = "REPLACE_THIS_WITH_YOUR_FULL_SCREEN_AD_ZONE_ID";
          rewardedVideoAdZoneId = "vz86d06e9ecbb54a5786";
      }
      window.adcolony.setUp(appId, fullScreenAdZoneId, rewardedVideoAdZoneId);
    // -- /AdColony Setup

    window.addEventListener("orientationchange", function() {
      if(!ADSMODULE.getNoAds()){
        admobSvc.destroyBannerView();
        admobSvc.createBannerView();
      }
    });
    //== end admob problem fix



    $rootScope.unreadMsgs = {nr:0, chatActive: 0};
    $rootScope.clan = { members :'' , info : ''};
    $rootScope.noAds = ADSMODULE.getNoAds();
    $rootScope.Lang = window.localStorage.getItem('defLang') || 'en';
    // store
    // Our application's global object
    (function(){
        var sell = {};
        sell.nonHostedContentUrl = "";


        // initialize the purchase plugin if available
        sell.initStore = function() {
            if (!window.store) {
                //console.log('Store not available');
                return;
            }
            sell.platform = device.platform.toLowerCase();
            // Enable maximum logging level
            //store.verbosity = store.DEBUG; 
             store.verbosity = store.QUIET;
            if(device.platform === "Android") {
              store.register({
                  id:    'noads', // id without package name!
                  alias: 'remove ads',
                  type:   store.NON_CONSUMABLE
              });
            }
            else {
              store.register({
                  id:    'noadsIOS2', // id without package name!
                  alias: 'remove ads',
                  type:   store.NON_CONSUMABLE
              });
            }

            store.error(function(error) {
              //console.log("Store.error",error);
                //log('ERROR ' + error.code + ': ' + error.message);
            });

            store.when("remove ads").approved(function (order) {
                //alert('Please restart the app');
                ADSMODULE.setNoAds(true);
                $rootScope.noAds = ADSMODULE.getNoAds();
                order.finish();
            });

            /*store.when("remove ads").updated(function (){
                noAds = true;
                 if(typeof AdMob  !== 'undefined'){
                    AdMob.removeBanner();
                    $timeout.cancel(adInter);
                }
            });*/
            store.when("remove ads").owned(function (){
                ADSMODULE.setNoAds(true);
                $rootScope.noAds = ADSMODULE.getNoAds();
                admobSvc.destroyBannerView();
                $timeout.cancel(adInter);
                
                 if(typeof AdMob  !== 'undefined'){
                    AdMob.removeBanner();
                    $timeout.cancel(adInter);
                }
            });
            

            store.ready(function() {
                
            });

            store.refresh();
        };

        sell.renderIAP = function(p) {

        };

        sell.initStore();
    }());
    


    



    // Analitics
    if (typeof analytics !== 'undefined'){

        analytics.startTrackerWithId(device.platform == "Android" ? 'UA-40547374-4': 'UA-40547374-5');
    }
    if (window.cordova) {
      cordova.getAppVersion.getVersionNumber(function (version) {
          $rootScope.appVersion = version;
          appVersion = version;
      });
    }

    // Handle onPause event

    document.addEventListener("pause", onPause, false);

    function onPause() {
        // Handle the pause event
        $timeout.cancel(adInter);
    }

    /*

              Admob Setup
    */

    (function(){
        // disable ads for android 4.1
        if(window.device && device.platform === 'Android' && (device.version >= '4.2') && !ADSMODULE.getNoAds()){
          admobSvc.createBannerView();
            window.adInter = $timeout(function() {
              if(Constants.DEBUGMODE){
                  console.info("Show Interstitial Ad");
              }
              if(!ADSMODULE.getNoAds()){
                //if(FacebookAds) FacebookAds.prepareInterstitial( {adId:'842668592456618_970795122977297', autoShow:true} );
                admobSvc.requestInterstitialAd();
                //AdMob.showInterstitial();
              }
              
            },300000);
        } 

        // IOS Devices
        else if (window.device && device.platform !== 'Android'  && !ADSMODULE.getNoAds()){
          admobSvc.createBannerView();
            window.adInter = $timeout(function() {
              if(Constants.DEBUGMODE){
                  console.info("Show Interstitial Ad");
              }
              if(!ADSMODULE.getNoAds()){
                admobSvc.requestInterstitialAd();
                //AdMob.showInterstitial();
              }
              
            },300000);
        } 

        // Android 4.1 or lower
        else {

          // show the interstitial later, e.g. at end of game level
          if(typeof AdMob  !== 'undefined'  && !ADSMODULE.getNoAds()) {
            window.adInter = $timeout(function() {
                if(Constants.DEBUGMODE){
                    console.info("Show Interstitial Ad");
                }
                if(!ADSMODULE.getNoAds()){
                  admobSvc.requestInterstitialAd();
                  //AdMob.showInterstitial();
                }
                
              },180000);
          } 
        }  

      }())
    


      /*
                       PUSH NOTIFICATIONS ......
      */
      
    if(typeof PushNotification !== 'undefined'){
      
    
      var push = PushNotification.init({ "android": {"senderID": "256167264068"},
         "ios": {"alert": "true", "badge": "true", "sound": "true"}, "windows": {} } );
      // Push Registration
      push.on('registration', function(data) {
        // data.registrationId
        if (ionic.Platform.isIOS()) {
          window.localStorage.setItem('regId',data.registrationId);
          AuthService.updateRegId('ios');
        }
        if (ionic.Platform.isAndroid()) {
          window.localStorage.setItem('regId',data.registrationId);
          AuthService.updateRegId('android');
        }
          
      });

      push.on('notification', function(data) {
          // data.message, data.title, data.count, data.sound, data.image, data.additionalData, data.additionalData.foreground

          if (ionic.Platform.isAndroid()) {
            if (data.additionalData.foreground) {
              // -- Show inforamtion if user has the app open on the time of the notification for Android
              //$ionicLoading.show({ template: data.message, noBackdrop: true, duration: 5000 });
              //console.log("Push msg data:", data);
              if($state.current.name.indexOf("app.clan.chat") === -1 && !$rootScope.unreadMsgs.chatActive) {
                    $rootScope.unreadMsgs.nr++;
                }


            } else {
                //console.log("Push msg data:", data);
                if (event.coldstart) {
                } else {
                }
                if(data.additionalData.payload && data.additionalData.payload.page) {
                  window.location = '#/app/'+data.additionalData.payload.page;
                }else{
                  window.location = '#/app/showPushMsg';
                }
            }

            // navigator.notification.alert(data.message);
            // var a = [];
            // a = JSON.parse(localStorage.getItem('pushMessages'));
            // a.push(data.message);
            // localStorage.setItem('pushMessages', JSON.stringify(a));
          }

          // IOS
          if (ionic.Platform.isIOS()) {
            if (data.additionalData.foreground) {
              // -- Show inforamtion if user has the app open on the time of the notification for IOS
              //$ionicLoading.show({ template: data.message, noBackdrop: true, duration: 5000 });
              if( $state.current.name.indexOf("app.clan.chat") === -1 && !$rootScope.unreadMsgs.chatActive) {
                    $rootScope.unreadMsgs.nr++;
                }


            } else {
                if (event.coldstart) {
                } else {
                }
                if(data.additionalData.payload && data.additionalData.payload.page) {
                  window.location = '#/app/'+data.additionalData.payload.page;
                }else if(data.additionalData.page) {
                  window.location = '#/app/'+data.additionalData.page;  
                }else{
                  window.location = '#/app/clan/chat';
                }
            }

            // navigator.notification.alert(data.message);
            // var a = [];
            // a = JSON.parse(localStorage.getItem('pushMessages'));
            // a.push(data.message);
            // localStorage.setItem('pushMessages', JSON.stringify(a));
          }
      });

      push.on('error', function(e) {
          // e.message
      });

    }

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)

    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }

    if(window.StatusBar) {
      StatusBar.styleDefault();
    }

    if(Constants.DEBUGMODE){
      if (navigator.connection){
        var networkType = $cordovaNetwork.getNetwork();
        console.log("Network used on this machine : "+networkType);
      }
    
    }
  
  

  if(navigator.connection && !$cordovaNetwork.isOnline()){
    if(Constants.DEBUGMODE){
      console.log("No NETWORK FOUND");
      // at this point we need to broadcast a no network found event and the app.controller will get that and display the popup
      $rootScope.$broadcast('event:app-networkRequired');
    }
  }else{
    if(Constants.DEBUGMODE){
      console.log("NETWORK FOUND");
    }
  }

  });
  
  // init Authentication service
  AuthService.init();

  $rootScope.$on('event:auth-loginRequired', function() {
    //if login is required redirect to the app.start page
    AuthService.resetCookie();
    $state.go('app.start');
  });


  // on state change you want to check whether or not the state.
  // I'm trying to reach is protected 
  $rootScope.$on("$stateChangeStart", function(event, toState, toParams, fromState, fromParams){
    $ionicLoading.show({
      template: 'Loading.', duration : 2000
    });
    
    if(typeof toState.authenticate !== 'undefined' && !toState.authenticate && AuthService.isLoggedIn() ){
      // User is logged in redirect to profile page
      //console.log(AuthService.currentUser.info.clan_id,"123")
      if(AuthService.currentUser.info.clan_id){
        $state.transitionTo("app.war");
      }else{
        $state.transitionTo("app.profile");
      }
      
      event.preventDefault(); 
    }else if(toState.authenticate && !AuthService.isLoggedIn()){
      // User isn’t authenticated
      $state.transitionTo("app.auth");
      event.preventDefault(); 
    }/*else {
      $state.transitionTo("app.start");
      event.preventDefault(); 
    }*/
  });

  $rootScope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState, fromParams){
    $ionicLoading.hide();
  });

})

.config(function($stateProvider, $urlRouterProvider,$ionicConfigProvider ) {

  var defLang = window.localStorage.getItem('defLang') || 'en';
  $ionicConfigProvider.views.transition('android');

  // loging function
  var _onEnter = [
    'Constants',
    '$state',
    '$stateParams',
    function(C, $state, $stateParams){
      if(C.DEBUGMODE){
        console.log("Entering state : "+$state.current.name);
        console.log({
          currentState : $state.current,
          url : $state.current.url,
          route : $state.current.name,
          params : $stateParams
        })
      }
    }];

  var _onExit = [
    'Constants',
    '$state',
    function(C, $state){
      if(C.DEBUGMODE){
        console.log("Exiting state : "+$state.current.name);
      }
  }];



  // quick hack to load before the controller gets called
  var _ctrlFilter = function(options){
    var opts = angular.extend({
      dependencies : ['Constants','$state','$stateParams'],
      type : 'data', // or params
      data : {}
    }, options);

    opts.dependencies.push(function(C, $state, $stateParams, $q, Model){
      var deferred = $q.defer();

      if(opts.type === 'data'){
        // if we need to fetch some data get the model and $stageParams id then get the data
        var model = new Model();
        model.get($stateParams.id).then(function(response){
          if(C.DEBUGMODE){
            console.log("success fetching model's data");
          }

          return deferred.resolve({
            type: 'data',
            params : {
              model: model.info
            }
          });
          
        }, function(error){
          if(C.DEBUGMODE){
            console.log("error fetching model's data");
          }

          return deferred.reject();
        });

      }else{
        // otherwise we're merely passing in the data
        return deferred.resolve({
          type: 'data',
          params : {
            id: $stateParams.id
          }
        });
      }

      return deferred.promise;
    });

    return opts.dependencies;
  }

  $stateProvider
  // routing 
  .state('app', {
      url: "/app",
      abstract: true,
      templateUrl: "templates/app.html",
      controller: 'AppCtrl'
  })

  // starting page
  .state('app.start', {
      url: "/start",
      views: {
        'content@app': {
          controller: 'AppCtrl',
          templateUrl: "templates/index.html"
        }
      },
      authenticate : false,
      onEnter: _onEnter,
      onExit: _onExit
  })
  
  // authentication page
  .state('app.auth', {
      url: "/auth",
      views: {
        'content@app': {
          controller: 'AuthCtrl',
          templateUrl: "templates/auth/index.html"
        }
      },
      authenticate : false, 
      onEnter: _onEnter,
      onExit: _onExit
  })
  // Contact page
  .state('app.contact', {
      url: "/contact",
      views: {
        'content@app': {
          controller: 'ContactCtrl',
          templateUrl: "templates/contact/index.html",
        }
      },
      //authenticate : true, 
      onEnter: _onEnter,
      onExit: _onExit
  })
  // Help page
  .state('app.news', {
      url: "/news",
      views: {
        'content@app': {
          controller: 'NewsCtrl',
          templateUrl: "templates/news/news.html",
        }
      },
      //authenticate : true, 
      onEnter: _onEnter,
      onExit: _onExit
  })
  // FAQ page
  .state('app.faq', {
      url: "/faq",
      views: {
        'content@app': {
          controller: 'FaqCtrl',
          templateUrl: "templates/faq/faq.html",
        }
      },
      //authenticate : true, 
      onEnter: _onEnter,
      onExit: _onExit
  })
    // Videos page
  .state('app.videos', {
      url: "/videos",
      views: {
        'content@app': {
          controller: 'VideosCtrl',
          templateUrl: "templates/videos/videos.html",
        }
      },
      //authenticate : true, 
      onEnter: _onEnter,
      onExit: _onExit
  })
    // Video  page with view
  .state('app.videos.video', {
      url: "/:id",
      views: {
        'content@app': {
          controller: 'VideosCtrl',
          templateUrl: "templates/videos/play.html",
        }
      },
      //authenticate : true, 
      onEnter: _onEnter,
      onExit: _onExit
  })  
  // signup page
  .state('app.auth.signup', {
    url: "/signup",
    views: {
      'content@app': {
        controller: 'AuthCtrl',
        templateUrl: "templates/auth/signup.html"
      }
    },
    authenticate : false, 
    onEnter: _onEnter,
    onExit : _onExit
  })
  // signup page
  .state('app.auth.forgotpass', {
    url: "/forgotpass",
    views: {
      'content@app': {
        controller: 'AuthCtrl',
        templateUrl: "templates/auth/forgot_password.html"
      }
    },
    authenticate : false, 
    onEnter: _onEnter,
    onExit : _onExit
  })

  // logged user's profile page
  .state('app.profile', {
      url: "/profile",
      views: {
        'content@app': {
          controller: 'ProfileCtrl',
          templateUrl: "templates/profile/index.html"
        }
      },
      authenticate : true, 
      onEnter: _onEnter,
      onExit : _onExit
  })

  // clan members page
  .state('app.clan', {
      url: "/clan",
      cache: false,
      views: {
        'content@app': {
          controller: 'UsersCtrl',
          templateUrl: "templates/clan/index.html"
        }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
  // clan edit page
  .state('app.clan.edit', {
      url: "/edit",
      views: {
          'content@app': {
              controller: 'ClanEditCtrl',
              templateUrl: "templates/clan/edit.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
  // clan chat page
  .state('app.clan.chat', {
      url: "/chat",
      cache: false,
      views: {
          'content@app': {
              controller: 'showChatCtrl',
              templateUrl: "templates/clan/chat.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
  .state('app.clan.chat.room', {
      url: "/:room",
      cache: false,
      views: {
          'content@app': {
              controller: 'showChatCtrl',
              templateUrl: "templates/clan/chat.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
    // clan other page
  .state('app.clan.other', {
      url: "/other",
      views: {
          'content@app': {
              controller: 'showOtherCtrl',
              templateUrl: "templates/clan/other.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
      // Create Clan
  .state('app.clan_create', {
      url: "/clan_create",
      views: {
          'content@app': {
              controller: 'ClanCtrl',
              templateUrl: "templates/clan/create.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })

      // Search Clan
  .state('app.clan_join', {
      url: "/clan_join",
      views: {
          'content@app': {
              controller: 'ClanCtrl',
              templateUrl: "templates/clan/search.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })

    // Get clan player info
    .state('app.clan_player_info', {
      url: "/clan_player_info/:id",
      cache: false,
      views: {
          'content@app': {
              controller: 'clanPlayerCtrl',
              templateUrl: "templates/clan/player.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
    })
  // clan push msg
  .state('app.pushMsg', {
      url: "/pushMsg",
      views: {
          'content@app': {
              controller: 'pushMsgCtrl',
              templateUrl: "templates/clan/pushMsg.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })

  // show push msg
  .state('app.showPushMsg', {
      cache: false,
      url: "/showPushMsg",
      views: {
          'content@app': {
              controller: 'showMsgCtrl',
              templateUrl: "templates/clan/messages.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })

      // War Main Page
  .state('app.war', {
      url: "/war",
      cache: false,
      views: {
          'content@app': {
              controller: 'WarCtrl',
              templateUrl: "templates/war/index.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })

  .state('app.war.stats', {
      cache: false,
      url: "/stats",
      views: {
          'content@app': {
              controller: 'WarStatsCtrl',
              templateUrl: "templates/war/stats.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
  .state('app.war.info', {
      cache: false,
      url: "/info",
      views: {
          'content@app': {
              controller: 'WarInfoCtrl',
              templateUrl: "templates/war/info.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
  /*
  .state('app.war.suggest', {
      cache: false,
      url: "/suggest/:id",
      views: {
          'content@app': {
              controller: 'SuggestCtrl',
              templateUrl: "templates/war/suggest.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })

  .state('app.war.suggest.view', {
      cache: false,
      url: "/:id",
      views: {
          'content@app': {
              controller: 'SuggestViewCtrl',
              templateUrl: "templates/war/suggest_view.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
  */
  .state('app.war.archive', {
      cache: true,
      url: "/archive",
      views: {
          'content@app': {
              controller: 'WarArchiveCtrl',
              templateUrl: "templates/wararchive/warsArchive.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
  .state('app.war.archive.detail', {
      cache: true,
      url: "/:id",
      views: {
          'content@app': {
              controller: 'WarArchiveDetailCtrl',
              templateUrl: "templates/wararchive/warArchiveDetail.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
  .state('app.war.archive.info', {
      cache: true,
      url: "/info/:id",
      views: {
          'content@app': {
              controller: 'WarArchiveInfoCtrl',
              templateUrl: "templates/wararchive/warArchiveInfo.html"
          }
      },
      authenticate: true,
      onEnter: _onEnter,
      onExit : _onExit
  })
      // users/:id profile page
  .state('app.users.profile', {
      cache: false,
      url: "/:id",
      views: {
        'content@app': {
          controller: 'UserCtrl',
          templateUrl: "templates/users/profile.html"
        }
      },
      authenticate: true,
      resolve : {
        CtrlFilter : _ctrlFilter({
          dependencies : ['Constants', '$state', '$stateParams','$q', 'UserModel'],
          type : 'data'
        }) 
      },
      onEnter: _onEnter,
      onExit : _onExit
  });
  
  
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/start');
})
.config(['admobSvcProvider', function (admobSvcProvider) {
  // Optionally you can configure the options here:
  var admobid = {};
  if( /(android)/i.test(navigator.userAgent) ) { // for android
      admobid = {
          publisherId: 'ca-app-pub-2834221541821600/8200436979', // or DFP format "/6253334/dfp_example_ad"
          interstitialAdId: 'ca-app-pub-2834221541821600/7112989775'
      };
  } else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
      admobid = {
          publisherId: 'ca-app-pub-2834221541821600/9503004571', // or DFP format "/6253334/dfp_example_ad"
          interstitialAdId: 'ca-app-pub-2834221541821600/1404533370'
      };
  } else { // for windows phone
      admobid = {
          publisherId: 'ca-app-pub-2834221541821600/8200436979', // or DFP format "/6253334/dfp_example_ad"
          interstitialAdId: 'ca-app-pub-2834221541821600/7112989775'
      };
  }

  admobSvcProvider.setOptions({
    publisherId:          admobid.publisherId,  // Required
    interstitialAdId:     admobid.interstitialAdId,  // Optional
    tappxIdiOs:           "/XXXXXXXXX/Pub-XXXX-iOS-IIII",            // Optional
    tappxIdAndroid:       "/XXXXXXXXX/Pub-XXXX-Android-AAAA",        // Optional
    tappxShare:           0.5                                        // Optional
  });

  // Optionally configure the events prefix (by default set to 'admob:')
  admobSvcProvider.setPrefix('myTag~');
}])

.factory(("ionPlatform"), function( $q ){
        var ready = $q.defer();

        ionic.Platform.ready(function( device ){
            ready.resolve( device );
        });

        return {
            ready: ready.promise
        }
    })

// ----------------- TRANSLATE PART -----------------
.config(['$translateProvider', function($translateProvider){
  var defLang = window.localStorage.getItem('defLang') || 'en';
  // Adding a translation table for the English language
  $translateProvider.translations('en',langEn);
  
  // ------------- SPANISH -------------
  $translateProvider.translations('es',langEs);
  $translateProvider.translations('it',langIt);
  $translateProvider.translations('fr',langFr);
  $translateProvider.translations('tr',langTr);
  $translateProvider.translations('de',langDe);
  $translateProvider.translations('pt',langPt);
  $translateProvider.translations('nl',langNl);
  $translateProvider.translations('ru',langRu);
  $translateProvider.translations('ro',langRo);

  $translateProvider.preferredLanguage(defLang).fallbackLanguage(['en']);
  $translateProvider.useSanitizeValueStrategy('sanitize');
}])

.controller('LangController', function($rootScope, $scope, $ionicSideMenuDelegate, $translate) {
  
  $scope.languages = [
    {value: 'en', label: 'English'}
    ,{value: 'es', label: 'Español'}
    ,{value: 'fr', label: 'Français'}
    ,{value: 'it', label: 'Italiano'}
    ,{value: 'de', label: 'Deutsch'}
    ,{value: 'pt', label: 'Português'}
    ,{value: 'nl', label: 'Nederlands'}
    ,{value: 'ro', label: 'Română'}
    ,{value: 'tr', label: 'Türkçe'}
    ,{value: 'ru', label: 'Русский'}
  ];
  var currentLang = window.localStorage.getItem('defLang') || 'en';
  var index = _.findIndex($scope.languages, function(chr) {
    return chr.value == currentLang;
  });

  $scope.lang = $scope.languages[index].value;
  //console.log();

  $scope.ChangeLanguageSelect = function(){
        
    window.localStorage.setItem('defLang',$scope.lang);
    $rootScope.Lang = $scope.lang;
    $translate.use($scope.lang);
  }
  
	
	// $scope.ChangeLanguage = function(lang){
        
 //    window.localStorage.setItem('defLang',lang);
 //    $rootScope.Lang = lang;
	// 	$translate.use(lang);
	// }

})
.controller("BuyNoAds", function($scope, $translate, admobSvc) {
  //$scope.noAds = noAds;
  $scope.buy = function() {
      if(window.device  && window.store) {
          store.order("remove ads");
      }
  }
  $scope.restore = function() {
    if(window.device  && window.store) {
      store.refresh();
    }
  }
  // -- AdColony Reward Video
  $scope.adColonyReward = function() {
      console.log(admobSvc);
      //
      window.adcolony.onRewardedVideoAdCompleted = function() {
          //alert('The Reward Video was watched');
          // Set the timer and remove the ADS
        ADSMODULE.setNoAdsTime();
        if( admobSvc != undefined) { 
          admobSvc.destroyBannerView(); 
        }

      };
      window.adcolony.showRewardedVideoAd();
  }
  // -- Finish AdColony Reward Video
})
.controller('AppLaunchedController', function($scope) {

  $scope.test = {
    hasLaunched : 'NO'
  };

  $scope.reportAppLaunched = function(url) {

    console.log('The app launched with URL : ' + url);
    
    $scope.$apply( function() {
      $scope.test.hasLaunched = 'YES';

    })
  }
});

function handleOpenURL(url) {

    var body = document.getElementsByTagName("body")[0];
    var appLaunchedController = angular.element(body).scope();
    appLaunchedController.reportAppLaunched(url);

};

