(function(){
  'use strict';

  var ArmyCtrl = function ($state, ArmyService, army, $stateParams) {
      var id = $stateParams.id;
      var self = this;
      self.Math = window.Math;
      self.army = army.data;
      
      self.form = army.user;

      self.submit = function() {
          ArmyService.submit(self.form, id).then(function(response){
              if (typeof analytics !== 'undefined') {
                    analytics.trackEvent('User', 'Updated army');
                }
                if(id === undefined)
                  $state.go("app.profile");
                else
                  $state.go("app.clan");
          },
          function() {
            alert('Error');
          }
          );
      }

  }

  ArmyCtrl.resolve = {
    army : [
      'ArmyService','$stateParams',
      function(ArmyService,$stateParams) {
        return ArmyService.getArmy($stateParams.id)
          .then(function(response){
            return response.data;
          });
      }
    ]
  }

  angular
    .module('controllers.army',['services.army'])

    .config(['$stateProvider', function ($stateProvider) {
      $stateProvider
        .state('app.army', {
          cache: false,
          url: '/army',
          views: {
              'content@app': {
                  controller: 'ArmyCtrl as army',
                  // create a instance so you can use the this keyWord
                  templateUrl: "templates/army/army.html",
                  resolve: ArmyCtrl.resolve

              }
          },
          
          //resolve: ArmyCtrl.resolve
          //authenticate: true,
          //onEnter: _onEnter,
          //onExit : _onExit
        })
        .state('app.armyuser', {
          cache: false,
          url: '/army/:id',
          views: {
              'content@app': {
                  controller: 'ArmyCtrl as army',
                  // create a instance so you can use the this keyWord
                  templateUrl: "templates/army/army.html",
                  resolve: ArmyCtrl.resolve

              }
          },
          
          //resolve: ArmyCtrl.resolve
          //authenticate: true,
          //onEnter: _onEnter,
          //onExit : _onExit
        })
    }])

    .controller('ArmyCtrl', ['$state', 'ArmyService','army','$stateParams', ArmyCtrl]);
})();
