'use strict';
function externalBrowser(link){
              //alert(link);
              var browserWindow = window.open( link, "_system", "location=yes");
            }
/*
 * controllers/clan/chat.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */
var serverBaseUrl = 'http://chat.clashofclanswarplan.com';

angular.module('controllers.clan.chat', ['yaru22.angular-timeago','ngCordova.plugins.camera','btford.socket-io'])

    .controller('showChatCtrl', [
        '$http',
        '$ionicLoading',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        'timeAgo',
        'socket',
        '$cordovaCamera',
        '$ionicScrollDelegate',
        '$ionicModal',
        '$ionicSlideBoxDelegate',
        '$interval',
        '$cordovaClipboard',
        '$sce',
        function($http, $ionicLoading, $timeout, $scope, $state, $stateParams, Constants, AuthService, timeAgo, socket, $cordovaCamera, $ionicScrollDelegate, $ionicModal, $ionicSlideBoxDelegate, $interval, $cordovaClipboard,$sce) {
            //show loading gif
            //timeAgo.settings.overrideLang = $scope.Lang;
            var isIOS = ionic.Platform.isWebView() && ionic.Platform.isIOS();
            $scope.zoomMin = 1;
            
            $ionicLoading.show({
                template: 'Loading messages...'
            });

            if(Constants.DEBUGMODE){
                console.log("PushMsgController controller");
                console.log($stateParams);
            }
            if(typeof analytics !== 'undefined'){
                analytics.trackView("Chat");
            }

            $scope.$watchCollection('messages', function (oldVal, newVal) {
                var animate = oldVal.length !== newVal.length;
                $ionicScrollDelegate.$getByHandle('chatScroll').scrollBottom(animate);
            });
            window.sk = socket;

            $scope.data = {};
            $scope.sendMessage = sendMessage;
            $scope.inputUp = inputUp;
            $scope.inputDown = inputDown;
            $scope.closeKeyboard = closeKeyboard;
            $scope.sendPicture = sendPicture;
            $scope.showImages = showImages;
            $scope.closeModal = closeModal;
            $scope.showModal = showModal;
            $scope.updateSlideStatus = updateSlideStatus;
            $scope.copyChatText = copyChatText;

            window.addEventListener('native.keyboardhide', function(){
                $ionicScrollDelegate.$getByHandle('chatScroll').scrollBottom(true);
            });

            function copyChatText(chatText) {

                $cordovaClipboard
                    .copy(chatText)
                    .then(function () {
                      $ionicLoading.show({template: '<i class="ion-ios-copy-outline"></i>',duration:700});
                    }, function () {
                      // error
                    });
            }

            $scope.urlify = function(text) {
                var urlRegex = /(https?:\/\/[^\s]+)/g;
                //$scope.$apply();
                return $sce.trustAsHtml(text.replace(urlRegex, function(url) {
                    return '<a onclick="externalBrowser(\'' + url + '\')" >' + url + '</a>';
                }));

            }


            function showModal(templateUrl) {
              $ionicModal.fromTemplateUrl(templateUrl, {
                scope: $scope
              }).then(function(modal) {
                $scope.modal = modal;
                $scope.modal.show();
              });
            };
             
            function closeModal() {
              $scope.modal.hide();
              $scope.modal.remove()
            };

            function updateSlideStatus(slide) {
              var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandle').getScrollPosition().zoom;
              if (zoomFactor == $scope.zoomMin) {
                $ionicSlideBoxDelegate.enableSlide(true);
              } else {
                $ionicSlideBoxDelegate.enableSlide(false);
              }
            };

            function showImages(index) {
                $scope.activeSlide = index;
                //console.log($scope.activeSlide);
                $scope.showModal('templates/modal/gallery-zoomview.html');
            };

            function sendPicture () {
                var options = {
                  quality: 80,
                  destinationType: Camera.DestinationType.DATA_URL,
                  sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                  encodingType: Camera.EncodingType.JPEG,
                  mediaType: Camera.MediaType.PICTURE,
                  targetWidth: 1280,
                  targetHeight: 720,
                  allowEdit: true,
                  correctOrientation: true
                };
                $cordovaCamera.getPicture(options).then(function(imageData) {
                  $ionicLoading.show({ template: "<ion-spinner class='spinner-energized'></ion-spinner>", noBackdrop: true, duration: 1000 });
                  socket.emit('new message', {
                    room: $scope.room,
                    username: $scope.username,
                    userId : $scope.userId,
                    message: "data:image/jpeg;base64," +imageData,
                    type: "picture"
                  });
                }, function(err) {
                  // error
                  alert('Failed because: ' + err);
                });
                
            }
             
            function handleError (err) {
                $log.error('profile save error ', err);
                $ionicPopup.alert({
                  title: err.reason || 'Save failed',
                  template: 'Please try again',
                  okType: 'button-positive button-clear'
                });
            }

            function sendMessage () {
                if (_.isEmpty($scope.data.message)) {
                    return;
                }

                socket.emit('new message', {
                    room: $scope.room,
                    username: $scope.username,
                    userId : $scope.userId,
                    message: $scope.data.message,
                    type: "text"
                });

                delete $scope.data.message;
            }

            function inputUp (target) {
                
                if(isIOS) {
                    $scope.data.keyboardHeight = 216;
                }
                $timeout(function() {
                    $ionicScrollDelegate.$getByHandle('chatScroll').scrollBottom(true);
                }, 300);
            }

            function inputDown () {

                if(isIOS) {
                    $scope.data.keyboardHeight = 0;
                }
                $timeout(function() {
                    // if(AdMob)
                    //  AdMob.showBanner(AdMob.AD_POSITION.BOTTOM_CENTER); 
                }, 300);

                $ionicScrollDelegate.$getByHandle('chatScroll').resize();
            }

            function closeKeyboard () {
                // cordova.plugins.Keyboard.close();
            }



            // new chat app with node backend
            $scope.data = {};
            $scope.data.type = 'text';
            $scope.moreMessages = true;
            $scope.data.message = '';
            $scope.messages = [];
            $scope.title = "";

            if($stateParams.room ){
                $scope.room     = $scope.user && $scope.user.clan_id || 'general';
                $scope.room = $scope.room + "_" + $stateParams.room;
                if($stateParams.room == 'war') {
                    $scope.title = "menu.war";
                }else if ($stateParams.room == 'co'){
                    $scope.title = "Co-Leader";
                }
                $scope.title
            }else{
                $scope.room     = $scope.user && $scope.user.clan_id || 'general';
                $scope.title = "menu.clan";
            }
            //$scope.room     = $scope.user && $scope.user.clan_id || 'general';
            $scope.username = $scope.user.name;
            $scope.userId   = $scope.user.objectId;
            $scope.getMessages = getMessages;
            $scope.getMessages();
            $scope.getMoreChat = getMoreChat;

            function getMessages() {
                $ionicLoading.show({ template: '<ion-spinner></ion-spinner>', duration: 4000});
                $http.get(serverBaseUrl + '/msg?room=' + $scope.room ).success(function (msgs) {
                    $scope.messages = msgs;
                    $timeout(function(){$ionicScrollDelegate.$getByHandle('chatScroll').scrollBottom(true)}, 1000);
                    
                    //window.msgs = msgs;
                    $ionicLoading.hide();
                });
            };

            function getMoreChat() {
                var dateval = _.first(_.sortBy($scope.messages, 'created')).created;
                $ionicLoading.show({ template: '<ion-spinner></ion-spinner>', duration: 4000});
                $http.get(serverBaseUrl + '/msgmore?room=' + $scope.room + "&dateval=" + dateval).success(function (msgs) {
                    if( _.isEmpty(msgs)) {
                        $scope.moreMessages = false;
                        console.log("all done...");
                    }
                    _.forEach(msgs, function(msg) {
                        $scope.messages.push(msg);
                    })
                    //$scope.messages.push(msgs);
                    //window.msgs.push(msgs);
                    $ionicLoading.hide();
                });
            }

            

            socket.emit('switch room', {
                    newRoom: $scope.room ,
                    username: $scope.username
            });

            window.socket = socket;

            socket.on('reconnect', function(){

                $http.get(serverBaseUrl + '/msg?room=' + $scope.room).success(function (msgs) {
                    $scope.messages = msgs;
                });
                socket.emit('switch room', {
                    newRoom: $scope.room ,
                    username: $scope.username
                });
            });
            //Listen for new messages (Objective 3)
            socket.on('message created', function (data) {
                //Push to new message to our $scope.messages
                $scope.messages.push(data);
                //Empty the textarea
                // if(data.userId === $scope.userId){
                //     $scope.data.message = "";    
                // }
                if($state.current.name !== "app.clan.chat") {
                    $scope.unreadMsgs.nr++;
                }
            });
            //Send a new message (Objective 4)
            $scope.sendNode = function (msg) {
                if (_.isEmpty($scope.data.message)) {
                    return;
                }

                //Notify the server that there is a new message with the message as packet
                socket.emit('new message', {
                    room: $scope.room,
                    username: $scope.username,
                    userId : $scope.userId,
                    message: msg.message,
                    type: msg.type
                });
                delete $scope.data.message;

            };

            // end of new chat app


            $scope.$on('$ionicView.enter', function(){ 
                // Reset unreadMsg count
                $scope.unreadMsgs.nr = 0;
                $scope.unreadMsgs.chatActive = 1;
            });


            $scope.$on("$destroy", function() {
                //console.log("stopped....");
                //$interval.cancel(promiseChat);
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });

            $ionicLoading.hide();

        }])
.factory('socket', function (socketFactory) {
    var myIoSocket = io.connect(serverBaseUrl, {
    'reconnection delay': 1000,
    'reconnection limit': 1000,
    'max reconnection attempts': 'Infinity',
    'forceNew':true
  });

    var socket = socketFactory({
        ioSocket: myIoSocket
    });

    return socket;
}).directive('ngEnter', function () {
    return function (scope, element, attrs) {
        element.bind("keydown keypress", function (event) {
            if (event.which === 13) {
                scope.$apply(function () {
                    scope.$eval(attrs.ngEnter);
                });

                event.preventDefault();
            }
        });
    };
}).directive('input', 
 
// The directive enable sending message when tapping return
// and expose the focus and blur events to adjust the view
// when the keyboard opens and closes
function input ($timeout) {
  return {
    restrict: 'E',
    scope: {
      'returnClose': '=',
      'onReturn': '&',
      'onFocus': '&',
      'onBlur': '&'
    },
    link: link
  };
 
  ////////////
 
  function link (scope, element, attrs) {
    element.bind('focus', function (e) {
      if (!scope.onFocus) return;
 
      $timeout(function () {

        scope.onFocus();
      });
    });
 
    element.bind('blur', function (e) {
      if (!scope.onBlur) return;
 
      $timeout(function () {
        scope.onBlur();
      });
    });
 
    element.bind('keydown', function (e) {
      if (e.which != 13) return;
 
      if (scope.returnClose) {
        element[0].blur();
      }
 
      if (scope.onReturn) {
        $timeout(function () {
          scope.onReturn();
        });
      }
    });
  }
});


