'use strict';

/*
 * controllers/profile/main.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.clan.edit', [])

    .controller('ClanEditCtrl', [
        '$http',
        '$q',
        '$ionicActionSheet',
        '$ionicModal',
        '$ionicLoading',
        '$ionicPopup',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        function($http,$q, $ionicActionSheet, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $scope,$state, $stateParams, Constants, AuthService) {
            //show loading gif
            $ionicLoading.show({
                template: 'Loading...'
            });

            if(Constants.DEBUGMODE){
                console.log("News controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";

            if(typeof analytics !== 'undefined'){
                analytics.trackView("Contact Form");
            }

            $scope.news = [];
            
            $scope.getClanInfo = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading war stats...'
                });

                var success = function(response, status, headers, config){
                    $scope.clan= response.payload;
                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.title= error.message;
                    $ionicLoading.hide();

                    deferred.reject(error);
                }
                $scope.user = AuthService.currentUser.info;
                $http.get(Constants.API.baseUrl+'/clan/edit').success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }();

            $scope.send = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading war stats...'
                });

                var success = function(response, status, headers, config){
                    //$scope.msg= response.payload.msg;
                    
                    $ionicLoading.hide();
                    $ionicLoading.show({ template: response.payload.msg, noBackdrop: true, duration: 2000 });
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.msg= error.message;
                    $ionicLoading.hide();
                    //$scope.$destroy();
                    //AuthService.logout().then(function(){$state.go("app.auth")});
                    //return $state.go("app.auth");

                    deferred.reject(error);
                }
                $scope.user = AuthService.currentUser.info;
                $http.post(Constants.API.baseUrl+'/clan/edit',{data: $scope.clan}).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }
            
            

            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });

            $ionicLoading.hide();
        }]);