'use strict';

/*
 * controllers/profile/main.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.clan.showMsg', [])

    .controller('showMsgCtrl', [
        '$http',
        '$q',
        '$ionicActionSheet',
        '$ionicModal',
        '$ionicLoading',
        '$ionicPopup',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        function($http,$q, $ionicActionSheet, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $scope,$state, $stateParams, Constants, AuthService) {
            //show loading gif
            $ionicLoading.show({
                template: 'Loading messages...'
            });

            if(Constants.DEBUGMODE){
                console.log("PushMsgController controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";

            // putting the current authenticated user in the $scope.user
            if(typeof analytics !== 'undefined'){
                analytics.trackView("Show Msg Page");
            }


            $scope.clanMsg=[];
            $scope.localMsg = JSON.parse(localStorage.getItem('pushMessages'));

            //$scope.correctlySelected = $scope.options[4];


            $scope.data = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading clan messages'
                });

                var success = function(response, status, headers, config){
                    $scope.clanMsg = response.payload;
                    $scope.mMsg = response.message;

                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.mMsg= error.message;
                    $ionicLoading.hide();

                    deferred.reject(error);
                }

                $http.get(Constants.API.baseUrl+'/getPushMsg').success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }
            $scope.data();


            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });

            $ionicLoading.hide();

        }]);