'use strict';

/*
 * controllers/clan/chat.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.clan.other', [])

    .controller('showOtherCtrl', [
        '$http',
        '$q',
        '$ionicActionSheet',
        '$ionicModal',
        '$ionicLoading',
        '$ionicPopup',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        '$interval',
        function($http,$q, $ionicActionSheet, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $scope, $state, $stateParams, Constants, AuthService,$interval) {
            //show loading gif
            $ionicLoading.show({
                template: 'Loading messages...'
            });

            if(Constants.DEBUGMODE){
                console.log("PushMsgController controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";


            // putting the current authenticated user in the $scope.user
            if(typeof analytics !== 'undefined'){
                analytics.trackView("Show Clan Other Page");
            }
            $scope.clanOther = [];

            $scope.data = function(){
                var deferred = $q.defer();

                var success = function(response, status, headers, config){
                    $scope.clanOther.voting = response.voting;
                    $scope.clanOther.messages = response.messages;
                    $scope.clanOther.logs = response.logs;
                    /*$ionicLoading.hide();*/
                    deferred.resolve(response);
                }

                // error callback
                var error = function(error, status, headers, config){

                    console.error("Error retriving data");
                    /*$ionicLoading.hide();*/
                    deferred.reject(error);
                }

                $http.post(Constants.API.baseUrl+'/clan/others',{}).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }
            $scope.data();


            $scope.vote = function(option){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Sending vote'
                });

                var success = function(response, status, headers, config){
                    $scope.data();
                    if(typeof analytics !== 'undefined'){
                        analytics.trackView("Vote Sent");
                    }


                    $ionicLoading.hide();
                    deferred.resolve(response);
                }

                // error callback
                var error = function(error, status, headers, config){
                    console.error("Error posting data");
                    $ionicLoading.hide();
                    deferred.reject(error);
                }

                $http.post(Constants.API.baseUrl+'/clan/vote',{id:id,option:option}).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;
            }

            $ionicModal.fromTemplateUrl('create_vote.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
                $scope.modal = modal;
            });
            $scope.openModal = function() {
                $scope.modal.show();
            };
            $scope.closeModal = function() {
                $scope.modal.hide();
            };
            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function() {
                $scope.modal.remove();
            });
            // Execute action on hide modal
            $scope.$on('modal.hidden', function() {
                // Execute action
            });
            // Execute action on remove modal
            $scope.$on('modal.removed', function() {
                // Execute action
            });

            $scope.newVoting = function(){
                $scope.openModal();
            }


            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });

            $ionicLoading.hide();

        }]);