'use strict';

/*
 * controllers/profile/main.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.clan.player', [])

    .controller('clanPlayerCtrl', [
        '$http',
        '$q',
        '$ionicActionSheet',
        '$ionicModal',
        '$ionicLoading',
        '$ionicPopup',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        function($http,$q, $ionicActionSheet, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $scope,$state, $stateParams, Constants, AuthService) {
            //show loading gif
            $ionicLoading.show({
                template: 'Loading ...'
            });

            if(Constants.DEBUGMODE){
                console.log("PushMsgController controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";

            // putting the current authenticated user in the $scope.user
            if(typeof analytics !== 'undefined'){
                analytics.trackView("player page");
            }

            $scope.playerId = $stateParams.id;
            $scope.player={};
            $scope.newWarW = {val:0};

            //$scope.correctlySelected = $scope.options[4];


            $scope.data = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading clan members'
                });

                var success = function(response, status, headers, config){
                    $scope.player = response.payload;
                    $scope.newWarW.val = $scope.player.war_weight;
                    $scope.mMsg = response.message;

                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.mMsg= error.message;
                    $ionicLoading.hide();

                    deferred.reject(error);
                }

                $http.get(Constants.API.baseUrl+'/clan/player/'+$scope.playerId).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }
            $scope.data();

            $scope.saveNewWarW = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: '<ion-spinner></ion-spinner>'
                });

                var success = function(response, status, headers, config){
                    $scope.data();
                }

                // error callback
                var error = function(error, status, headers, config){
                    alert(error);
                    $ionicLoading.hide();

                    deferred.reject(error);
                }

                $http.post(Constants.API.baseUrl+'/clan/player/updWarWeight/'+$scope.playerId,{weight:$scope.newWarW.val}).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;
            }

            if($stateParams.id !== 'undefended'){

            }
          
            $scope.action = function(action,id) {
              if(Constants.DEBUGMODE){
                console.log(action + " player "+id);
                
              }
              
              var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading clan members'
                });

                var success = function(response, status, headers, config){
                    $scope.data();

                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.mMsg= error.message;
                    $ionicLoading.hide();

                    deferred.reject(error);
                }

                $http.get(Constants.API.baseUrl+'/clan/player/'+action+'/'+id).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;
              
            }
            


            $scope.showConfirm = function(name,action,id) {
             var confirmPopup = $ionicPopup.confirm({
               title: '',
               template: '<div translate="site.are_you_sure_x"></div>'
             });
             confirmPopup.then(function(res) {
               if(res) {
                 $scope.action(action,id);
               } else {
                 
               }
             });
           };







            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });
            $ionicLoading.show({
                template: 'Loading.....'
            });

            $ionicLoading.hide();

        }]);