'use strict';

/*
 * controllers/profile/main.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.clan.pushMsg', [])

    .controller('pushMsgCtrl', [
        '$http',
        '$q',
        '$ionicActionSheet',
        '$ionicModal',
        '$ionicLoading',
        '$ionicPopup',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        function($http,$q, $ionicActionSheet, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $scope,$state, $stateParams, Constants, AuthService) {
            //show loading gif
            $ionicLoading.show({
                template: 'Loading ...'
            });

            if(Constants.DEBUGMODE){
                console.log("PushMsgController controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";

            // putting the current authenticated user in the $scope.user
            if(typeof analytics !== 'undefined'){
                analytics.trackView("PushMsg Page");
            }

            $scope.mesaj = '';
            $scope.members={};
            $scope.selected = {};

            //$scope.correctlySelected = $scope.options[4];


            $scope.data = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading clan members'
                });

                var success = function(response, status, headers, config){
                    $scope.members = response.payload;
                    $scope.mMsg = response.message;
                    angular.forEach($scope.members, function(value, key) {
                        $scope.selected[key] = true;
                    });

                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.mMsg= error.message;
                    $ionicLoading.hide();

                    deferred.reject(error);
                }

                $http.get(Constants.API.baseUrl+'/getPushList').success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }
            $scope.data();

            if($stateParams.id !== 'undefended'){

            }



            $scope.sendMsg = function(msg){
                if(Constants.DEBUGMODE){
                    console.log("Send PushMessage:");
                    console.log("Msg:" + msg);
                }
                var deferred = $q.defer();

                if(msg.length < 10){

                    $scope.sMsg = 'Message is to short. Minimum 10 characters';
                    return false;
                }
                if(msg.length > 250){
                    $scope.sMsg = 'Message is to big. Mix 250 characters';
                    return false;
                }

                msg = AuthService.currentUser.info.name+ ": "+msg;
                $ionicLoading.show({
                    template: 'Sending Message ...'
                });


                //$scope.enemy.setSetStars = $scope.correctlySelected.value;


                var success = function(response, status, headers, config){
                    if(typeof analytics !== 'undefined'){
                        analytics.trackEvent('PushMsg', 'Send');
                    }
                    $scope.msg = '';
                    $scope.sMsg=response.message;
                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.sMsg=error.message;
                    $ionicLoading.hide();
                    deferred.reject(error);
                }

                $http.post(Constants.API.baseUrl+'/sendPush', {msg:msg,users:$scope.selected}).success(success).error(error);

                return deferred.promise;
            }

            $scope.clearMsg = function(){
                $scope.sMsg = null;
            }





            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });
            $ionicLoading.show({
                template: 'Loading......'
            });

            $ionicLoading.hide();

        }]);