'use strict';

/*
 * controllers/profile/main.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.contact', ['pascalprecht.translate'])

    .controller('ContactCtrl', [
        '$http',
        '$q',
        '$ionicActionSheet',
        '$ionicModal',
        '$ionicLoading',
        '$ionicPopup',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        '$translate',
        function($http,$q, $ionicActionSheet, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $scope,$state, $stateParams, Constants, AuthService,$translate) {
            //show loading gif
            $ionicLoading.show({
                template: 'Loading...'
            });

            if(Constants.DEBUGMODE){
                console.log("ContactCtrl controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";

            if(typeof analytics !== 'undefined'){
                analytics.trackView("Contact Form");
            }

            // putting the current authenticated user in the $scope.user
            
            $scope.send = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading war stats...'
                });

                var success = function(response, status, headers, config){
                    $scope.msg= response;
                    $scope.form = {};
                    if($scope.user){
                        $scope.form.email = $scope.user.email;
                    }
                    
                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.title= error.message;
                    $ionicLoading.hide();
                    //$scope.$destroy();
                    //AuthService.logout().then(function(){$state.go("app.auth")});
                    //return $state.go("app.auth");

                    deferred.reject(error);
                }
                $scope.user = AuthService.currentUser.info;
                $http.post(Constants.API.baseUrl+'/contact',{data: $scope.form}).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }
            
            $scope.errorMsg = "";
            //$scope.msg = {};
            $scope.form = {};
            if($scope.user){
                $scope.form.email = $scope.user.email;
            }
            

            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });

            $ionicLoading.hide();
        }]);