'use strict';

/*
 * controllers/profile/main.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.faq', [])

    .controller('FaqCtrl', [
        '$http',
        '$q',
        '$ionicActionSheet',
        '$ionicModal',
        '$ionicLoading',
        '$ionicPopup',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        function($http,$q, $ionicActionSheet, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $scope,$state, $stateParams, Constants, AuthService) {
            //show loading gif
            $ionicLoading.show({
                template: 'Loading...'
            });

            if(Constants.DEBUGMODE){
                console.log("faq controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";

            if(typeof analytics !== 'undefined'){
                analytics.trackView("faq Page");
            }

            $scope.faq = [];
            $scope.showfaq = [];
            $scope.appVersion = appVersion;
            $scope.toDate = function(dateString) {
                return new Date(dateString);
            }

            $scope.showFaq = function(n) {
                _.forEach($scope.showfaq, function(v,k){
                    $scope.showfaq[k] = false;
                });
                $scope.showfaq[n] = true;
            }
            
            $scope.getfaq = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading war stats...'
                });

                var success = function(response, status, headers, config){
                    $scope.faq= response;
                    _.forEach($scope.faq, function(v,k){
                        $scope.showfaq[v.id] = false;
                    });
                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.title= error.message;
                    $ionicLoading.hide();

                    deferred.reject(error);
                }
                $scope.user = AuthService.currentUser.info;
                $http.get(Constants.API.baseUrl+'/faq/'+$scope.appVersion).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }();
            
            

            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });
            $ionicLoading.hide();
            

        }]);