;
(function(){
  'use strict';

  var SuggestCtrl = function ($state, SuggestService, army, $stateParams,$ionicPopup,$ionicLoading,$cordovaCamera) {
      //self.army = army;

      var self = this;
      self.Math = window.Math;


      self.member = army;
      self.maxArmy = self.member.maxArmy;
      self.maxSpells = self.member.maxSpells;
      self.troops = [];
      self.spells = [];
      self.notes = '';
      self.img = null;

      angular.forEach(self.member.army, function (troop, key) {

          self.troops.push({
              id: troop.id,
              value: 0,
              name: troop.name,
              housing: troop.housing,
              max: troop.housing > 0 ? self.Math.floor(self.maxArmy / troop.housing) : 1,
              lvl: troop.pivot.lvl
          });
      });
      angular.forEach(self.member.spells, function (spell, key) {
          self.spells.push({
              id: spell.id,
              value: 0,
              name: spell.name,
              housing: spell.housing,
              max: spell.housing ? self.Math.floor(self.maxSpells / spell.housing) : 1,
              lvl: spell.pivot.lvl
          });
      });

      self.castle = self.member.castle;


      //self.$broadcast('scroll.refreshComplete');

      self.plusone = function (val) {
          if (val.value < val.max) {
              val.value = parseInt(val.value) + 1;
          }
          self.getMax();
          return true;
      }

      self.minusone = function (val) {
          if (val.value > 0) {
              val.value = parseInt(val.value) - 1;
          }
          self.getMax();
          return true;
      }

      self.sum = function (list) {
          var total = 0;
          angular.forEach(list, function (item) {
              total += parseInt(item.value);
          });
          return total;
      }
      self.getTotal = function () {
          var total = 0;
          for (var i = 0; i < self.troops.length; i++) {
              var product = self.troops[i];
              total += (product.value * product.housing);
          }
          return total;
      }

      self.getTotalSpells = function () {
          var total = 0;
          for (var i = 0; i < self.spells.length; i++) {
              var product = self.spells[i];
              total += (product.value * product.housing);
          }
          return total;
      }

      self.getMax = function () {
          var $this = this;
          var current = self.getTotal();
          var currentS = self.getTotalSpells();
          var free = self.maxArmy - current;
          var freeSpell = self.maxSpells - currentS;
          angular.forEach(self.troops, function (troop, key) {
              if (troop.housing != 0) {
                  troop.max = self.Math.floor(free / troop.housing) + parseInt(troop.value);
              }
          });

          angular.forEach(self.spells, function (spell, key) {
              if (spell.housing != 0) {
                  spell.max = self.Math.floor(freeSpell / spell.housing) + parseInt(spell.value);
              }
          });

          return true;
      }


      /* Select image from phone */
      self.GetImg = function () {
          var options = {
            quality: 80,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            encodingType: Camera.EncodingType.JPEG,
            mediaType: Camera.MediaType.PICTURE,
            targetWidth: 960,
            targetHeight: 720,
            allowEdit: true
          };
          $cordovaCamera.getPicture(options).then(onSuccess, onFail);


          function onSuccess(imageData) {
              //var image = document.getElementById('myImage'.player);
              //image.src = imageData;
              $ionicLoading.show({
                  template: "Uploading Image"
              });
              self.UploadImg(imageData);
          }

          function onFail(message) {
              alert('Failed because: ' + message);
          }
      };

      /* Upload image to server */
      self.UploadImg = function (imageData) {
          var ft = new FileTransfer();
          var options = new FileUploadOptions();
          var serverUrl = "http://clashofclanswarplan.com/en/api/upload/";
          options.fileKey = 'file';
          options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
          options.mimeType = "image/jpeg";
          //options.params =
          options.headers = {'X-Access-Token': window.localStorage.getItem('sessionToken') || ""}
          ft.upload(imageData, serverUrl, onUploadSuccess, onUploadError, options);

          function onUploadSuccess(data) {
              if (typeof analytics !== 'undefined') {
                  analytics.trackEvent('War', 'Upload Suggest Img');
              }

              $ionicLoading.hide();
              var imgData = JSON.parse(data.response);
              $ionicPopup.alert({
                  title: 'Done',
                  template: "Image uploaded "
              });
              
              self.img = imgData.file;
              //console.log("upload info...:",self.img,data);
          }

          function onUploadError(error) {
              $ionicLoading.hide();
              $ionicPopup.alert({
                  title: 'Error',
                  template: "There was an error uploading the image."
              });
          }
      };

      self.submit = function () {
          // Done button is not selected
          if (!$scope.dne) {
            return;
          }
          //var self = this;
          var form = {};
          form.army = {};
          angular.forEach(self.troops, function (t) {
              //if(t.value > 0){
              form.army[t.id] = t.value;
              //}
          });
          form.spells = {};
          angular.forEach(self.spells, function (t) {
              //if(t.value > 0){
              form.spells[t.id] = t.value;
              //}
          });
          form.notes = self.notes;
          form.img = self.img;
          form.reserveId = $stateParams.id;
          form.playerNr = self.member.enemyId;
          //console.log(form);
          //return false;
          SuggestService.submit(form).then(function(response){
              if (typeof analytics !== 'undefined') {
                    analytics.trackEvent('War', 'Submit Suggestion');
                }
                $state.go("app.war.suggestview", {id: response.id});
          });

      }
            

        

  }

  SuggestCtrl.resolve = {
    army : [
      'SuggestService','$stateParams',
      function(SuggestService,$stateParams) {
        console.log("was here...");
        return SuggestService.getArmy($stateParams.id)
          .then(function(response){
            return response.data;
          });
      }
    ]
  }

  angular
    .module('controllers.suggest.suggest',['services.suggest','ngCordova.plugins.camera'])

    .config(['$stateProvider', function ($stateProvider) {
      $stateProvider
        .state('app.war.suggest', {
          cache: false,
          url: '/suggest/:id',
          views: {
              'content@app': {
                  controller: 'SuggestCtrl as suggest',
                  // create a instance so you can use the this keyWord
                  templateUrl: "templates/war/suggest.html",
                  resolve: SuggestCtrl.resolve

              }
          },
          
          //resolve: SuggestCtrl.resolve
          //authenticate: true,
          //onEnter: _onEnter,
          //onExit : _onExit
        })
    }])

    .controller('SuggestCtrl', ['$state', 'SuggestService','army','$stateParams', '$ionicPopup', '$ionicLoading','$cordovaCamera', SuggestCtrl]);


})();

