(function(){
  'use strict';

  var SuggestViewCtrl = function ($state, SuggestViewService, army,$ionicModal,$ionicScrollDelegate,$scope) {

      var self = this;
      self.Math = window.Math;
      self.member = army;
      self.s = self.member.data;
      self.maxArmy = self.member.maxArmy;
      self.maxSpells = self.member.maxSpells;
      self.troops = [];
      self.spells = [];
      self.notes = '';
      self.img = null;
      angular.forEach(self.member.army ,function(troop,key){
          self.troops.push({id:troop.id,value: 0, name: troop.name, housing: troop.housing, max: troop.housing > 0 ? self.Math.floor(self.maxArmy / troop.housing) : 1, lvl : troop.pivot.lvl});
      });

      angular.forEach(self.member.spells ,function(spell,key){
          self.spells.push({id: spell.id ,value: 0,name: spell.name, housing: spell.housing, max: spell.housing ? self.Math.floor(self.maxSpells / spell.housing) : 1, lvl : spell.pivot.lvl});
      });

      self.castle = self.member.castle;

      $scope.zoomMin = 1;
      $scope.showImages = showImages;
      $scope.closeModal = closeModal;
      $scope.showModal = showModal;
      $scope.updateSlideStatus = updateSlideStatus;

      function showModal(templateUrl) {
        $ionicModal.fromTemplateUrl(templateUrl, {
          scope: $scope
        }).then(function(modal) {
          $scope.modal = modal;
          $scope.modal.show();
        });
      };
       
      function closeModal() {
        $scope.modal.hide();
        $scope.modal.remove()
      };

      function updateSlideStatus(slide) {
        var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandle').getScrollPosition().zoom;
        if (zoomFactor == $scope.zoomMin) {
          $ionicSlideBoxDelegate.enableSlide(true);
        } else {
          $ionicSlideBoxDelegate.enableSlide(false);
        }
      };

      function showImages(index) {
          $scope.activeSlide = index;
          //console.log($scope.activeSlide);
          $scope.showModal('templates/modal/gallery-zoomview.html');
      };     

  }

  SuggestViewCtrl.resolve = {
    army : [
      'SuggestViewService','$stateParams',
      function(SuggestViewService,$stateParams) {
        return SuggestViewService.getArmy($stateParams.id)
          .then(function(response){
            return response.data;
          });
      }
    ]
  }

  angular
    .module('controllers.suggest.view',['services.suggest.view'])

    .config(['$stateProvider', function ($stateProvider) {
      $stateProvider
        .state('app.war.suggestview', {
          cache: false,
          url: '/suggestview/:id',
          views: {
              'content@app': {
                  controller: 'SuggestViewCtrl as suggestView',
                  // create a instance so you can use the this keyWord
                  templateUrl: "templates/war/suggest_view.html",
                  resolve: SuggestViewCtrl.resolve

              }
          },
          
          //resolve: SuggestViewCtrl.resolve
          //authenticate: true,
          //onEnter: _onEnter,
          //onExit : _onExit
        })
    }])

    .controller('SuggestViewCtrl', ['$state', 'SuggestViewService','army','$ionicModal','$ionicScrollDelegate','$scope', SuggestViewCtrl]);
})();
