(function(){
    'use strict';

    var TroopBarrkFact = function(barrkData) {

            this.barrk = {};
            this.barrk.name = barrkData[0];
            this.barrk.level = barrkData[1]; 
            this.barrk.boost = barrkData[2];
            this.barrk.elixir = barrkData[3];
            this.barrk.spells = barrkData[4] || false;
            if(!this.barrk.spells)  {
                if(this.barrk.elixir){
                    this.barrk.capacity = [0,20,25,30,35,40,45,50,55,60,75,80,85];
                }else{
                    this.barrk.capacity = [0,40,50,60,70,80,90,100];
                }
            }
            else{
                if(this.barrk.elixir){
                    this.barrk.capacity = [0,2,4,6,8,10];
                }else{
                    this.barrk.capacity = [0,2,4,6,8];
                }
            }

            this.barrk.space = this.barrk.capacity[this.barrk.level]; 
            this.barrk.maxSpace = this.barrk.capacity[this.barrk.level]; 
            this.barrk.trainTime = 0;
            this.barrk.troops = {}; 
             


        
            //console.log(name,space);

        };

        TroopBarrkFact.prototype.calcMaxSpace = function(level) {
        return this.barrk.capacity[level];
    }

        TroopBarrkFact.prototype.getName = function() {
                return this.barrk.name;
        };

        TroopBarrkFact.prototype.getSpace = function() {
                return this.barrk.space;
        };

        TroopBarrkFact.prototype.canTrain = function(unitName) {
            if(this.barrk.elixir && !this.barrk.spells){
              switch (unitName) {
                case 1: //"Barbarian" : 
                    if(this.barrk.level >= 1)
                        return true;
                    return false;
                case 2: //"Archer" : 
                    if(this.barrk.level >= 2)
                        return true;
                    return false;
                case 4: //"Giant":
                    if(this.barrk.level >= 3) 
                        return true;
                    return false;                
                case 3: //"Goblin" : 
                    if(this.barrk.level >= 4) 
                        return true;
                    return false;
                case 5: //"Wall Breaker" : 
                    if(this.barrk.level >= 5) 
                        return true;
                    return false;

                case 6: //"Balloon":
                    if(this.barrk.level >= 6) 
                        return true;
                    return false;
                case 7: //"Wizard":
                    if(this.barrk.level >= 7) 
                        return true;
                    return false;
                case 8: //"Healer":
                    if(this.barrk.level >= 8) 
                        return true;
                    return false;
                case 9: //"Dragon":
                    if(this.barrk.level >= 9) 
                        return true;
                    return false;
                case 10: //"P.E.K.K.A":
                    if(this.barrk.level >= 10) 
                        return true;
                    return false;
                case 21: //"Baby Dragon":
                    if(this.barrk.level >= 11) 
                        return true;
                    return false;
                case 22: //"Miner":
                    if(this.barrk.level >= 12) 
                        return true;
                    return false;
                default:
                    return false;
                }
            }
            
            if(this.barrk.elixir && this.barrk.spells){
              switch (unitName) {

                case 1: //"Lightning":
                    if(this.barrk.level >= 1) 
                        return true;
                    return false;
                case 2: //"Healing":
                    if(this.barrk.level >= 2) 
                        return true;
                    return false;
                case 3: //"Rage":
                    if(this.barrk.level >= 3) 
                        return true;
                    return false;
                case 4: //"Jump":
                    if(this.barrk.level >= 4) 
                        return true;
                    return false;
                case 5: //"Freeze":
                    if(this.barrk.level >= 4) 
                        return true;
                    return false;
                case 9: //"CLONE":
                    if(this.barrk.level >= 5) 
                        return true;
                    return false;

                default:
                    return false;
            }
      }
      
      if(!this.barrk.elixir  && !this.barrk.spells){
              switch (unitName) {
            case 11: //"Minion" : 
                if(this.barrk.level >= 1)
                    return true;
                return false;
            case 12: //"Hog Rider" : 
                if(this.barrk.level >= 2)
                    return true;
                return false;
            case 13: //"Valkyrie" : 
                if(this.barrk.level >= 3) 
                    return true;
                return false;
            case 14: //"Golem" : 
                if(this.barrk.level >= 4) 
                    return true;
                return false;
            case 15: //"Witch":
                if(this.barrk.level >= 5) 
                    return true;
                return false;
            case 16: //"Lava Hound":
                if(this.barrk.level >= 6) 
                    return true;
                return false;
            case 20: //"Bowler":
                if(this.barrk.level >= 7) 
                    return true;
                return false;
            default:
                return false;
            }
        }

        if(!this.barrk.elixir  && this.barrk.spells){
          switch (unitName) {

            case 6: //"Poison":
                if(this.barrk.level >= 1) 
                    return true;
                return false;
            case 7: //"Earthquake":
                if(this.barrk.level >= 2) 
                    return true;
                return false;
            case 8: //"Haste":
                if(this.barrk.level >= 3) 
                    return true;
                return false;
            case 10: //"Skeleton":
                if(this.barrk.level >= 4) 
                    return true;
                return false;

            
            default:
                return false;
        }
      } 
    }

        TroopBarrkFact.prototype.addTroopToTrain = function(troop){
        if(troop.getSpace() <= this.barrk.space) {
            this.barrk.space -= troop.getSpace();
            if(this.barrk.boost){
                this.barrk.trainTime += troop.getBuildTime() / 4;
            }else{
                this.barrk.trainTime += troop.getBuildTime();
            }

            if(this.barrk.troops && this.barrk.troops[troop.troop.name]){
                this.barrk.troops[troop.troop.name]++;
            }else{
                this.barrk.troops[troop.troop.name] = 1; 
            }
            
            //this.#(troop.getName()) = ++;
            return this.barrk.space;
        }
        return -1;
    }

        TroopBarrkFact.prototype.isBoost = function() {
                return this.barrk.boost;
        };


        TroopBarrkFact.prototype.setBoost = function(boost) {
                this.barrk.boost = boost;
        };

        TroopBarrkFact.prototype.getMaxSpace = function() {
                return this.barrk.maxSpace;
        };

        TroopBarrkFact.prototype.getSpace = function() {
                return this.barrk.space;
        };

        TroopBarrkFact.prototype.getTrainTime = function(){
                return this.barrk.trainTime;
        };





    angular
        .module('services.troopBarrk',[])
        .factory('TroopBarrkService',[
            '$injector',
            function ($injector) {
                return function(barrkData) { 
                    return $injector.instantiate(TroopBarrkFact, { barrkData: barrkData }); 
                };
            }
        ]);


})();


