(function(){
  'use strict';

  var TroopCtrl = function ($state, TroopService,TroopBarrkService,army, $stateParams, $scope,$ionicScrollDelegate) {
      var self = this;

      self.viewQ = true;
      self.viewB = false;
      self.troopCapacity = 200;
      self.spellCapacity = 9;
      self.maxTrainTime = 0;
      if(army.user && army.user.ac && army.user.ac.val){
        self.troopCapacity = army.user.ac.val;
      }
      self.troopCapacityRange = [0,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100,105,110,115,120,125,130,135,140,145,150,155,160,165,170,175,180,185,190,195,200,205,210,215,220,225,230,235,240];
      self.spellCapacityRange = [0,1,2,3,4,5,6,7,8,9,10,11];
      
      self.showQuantity = function(){
        self.viewQ = true;
        self.viewB = false;
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
      }
      self.showBarraks = function(){
        self.viewQ = false;
        self.viewB = true;
        $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
      }
      
      self.army=[];
      self.spells =[];
      self.barrks = [];
      self.spellFactories = [];

      for (var i = 0; i < 4; i++) {
        self.barrks.push(TroopBarrkService(['Barrack '+i,'10',false,true]));
      };
      for (var i = 0; i < 2; i++) {
        self.barrks.push(TroopBarrkService(['Dark Barrack '+i,'6',false,false]));
      };
      self.spellFactories.push(TroopBarrkService(['Spell Factory ','4',false,true,true]));
      self.spellFactories.push(TroopBarrkService(['Dark Spell Factory ','3',false,false,true]));
      

      window.barrks = self;
      self.totalArmyCost = {
        elixir : 0,
        dark: 0
      }
      //Troop(String name, int space, boolean isSpell, boolean elixir, int buildTime, int maxLvl, int currentLvl)
      _.forEach(army.data.a, function(unit){
        var currentLvl = "1";
        if(army.user && army.user.a && army.user.a[unit.id]){
          currentLvl = army.user.a[unit.id].toString();
        }
        self.army.push(TroopService([ unit.name,unit.space,false,unit.elixir,unit.buildTime,unit.maxlvl,currentLvl,JSON.parse(unit.levels), unit.id ]));
      });

      // Add the spells as well
      _.forEach(army.data.s, function(spell){
        var currentLvl = "1";
        if(army.user && army.user.s && army.user.s[spell.id]){
          currentLvl = army.user.s[spell.id].toString();
        }
        self.spells.push(TroopService([ spell.name,spell.space,true,spell.elixir,spell.buildTime,spell.maxlvl,currentLvl,JSON.parse(spell.levels), spell.id ]));
      });

      self.update = updateCosts;
      self.reset = reset;
      self.saveData = saveData;
      self.restoreData = restoreData;

      // Triggerd when army changes
      function updateCosts(){
        //console.clear();
        self.maxTrainTime = 0;
        var toAssignBarracks = [];
        var toAssignSpells = [];
        // reset army costs
        self.totalArmyCost = {
          elixir : 0,
          dark: 0,
          armySize: 0,
          spellSize: 0,
          army:[],
          spells:[]
        }
        // reset barraks
        _.forEach(self.barrks, function(b){
            b.barrk.troops = {};
            b.barrk.trainTime = 0;
            b.barrk.maxSpace =b.calcMaxSpace(b.barrk.level);
            b.barrk.space = b.barrk.maxSpace;
        });
        // reset spell factories
        _.forEach(self.spellFactories, function(b){
            b.barrk.troops = {};
            b.barrk.trainTime = 0;
            b.barrk.maxSpace =b.calcMaxSpace(b.barrk.level);
            b.barrk.space = b.barrk.maxSpace;
        });
        

        // calculate cost and add to barracks

        _.forEach(self.army, function(t,k){
          self.totalArmyCost.army[k] = t.getTotalTroopsCost();
          if(t.troop.elixir){
            self.totalArmyCost.elixir += self.totalArmyCost.army[k];
          }else{
            self.totalArmyCost.dark += self.totalArmyCost.army[k];
          }
          self.totalArmyCost.armySize += t.getTotalTroopsSpace();

          if(t.getCurrentUnits()){
              toAssignBarracks.push(t);
          }

        });

        // calculate cost and add to spell factories

        _.forEach(self.spells, function(t,k){
          self.totalArmyCost.spells[k] = t.getTotalTroopsCost();
          if(t.troop.elixir){
            self.totalArmyCost.elixir += self.totalArmyCost.spells[k];
          }else{
            self.totalArmyCost.dark += self.totalArmyCost.spells[k];
          }
          self.totalArmyCost.spellSize += t.getTotalTroopsSpace();

          if(t.getCurrentUnits()){
              toAssignSpells.push(t);
          }

        });
        
        // console.log(toAssignBarracks);
        // console.log(_.orderBy(toAssignBarracks, ['troop.buildTime', 'troop.space'], ['desc', 'desc']));
        // assing troops to barraks
        toAssignBarracks = _.orderBy(toAssignBarracks, ['troop.buildTime', 'troop.space'], ['desc', 'desc']);
        _.forEach(toAssignBarracks, function(t){
          //console.log("Processing "+t.getName());
          addUnitsToBarracks(t,self.barrks);  
        });

                // assing troops to barraks
        toAssignSpells = _.orderBy(toAssignSpells, ['troop.buildTime', 'troop.space'], ['desc', 'desc']);
        _.forEach(toAssignSpells, function(t){
          addUnitsToBarracks(t,self.spellFactories);  
        });

        for(var i = 0; i<6; i++){
          if(self.barrks[i].barrk.trainTime > self.maxTrainTime)
            self.maxTrainTime = self.barrks[i].barrk.trainTime;
        }

        if(typeof analytics !== 'undefined'){
            analytics.trackView("Troop Calculator");
        }



      }

      function saveData() {
        var backup = {};
        backup.troopCapacity = self.troopCapacity;
        backup.spellCapacity = self.spellCapacity;
        backup.army = self.army;
        backup.spells = self.spells;
        backup.barrks = self.barrks;
        backup.spellFactories = self.spellFactories;
        window.localStorage.setItem('troopCalcData' ,JSON.stringify(backup));
      }

      function restoreData() {
        var backup = JSON.parse(window.localStorage.getItem('troopCalcData'));
        if(backup && backup.army){
          _.forEach(backup.army, function (t,k){
            
            self.army[k].troop.currentUnits = t.troop.currentUnits;
            self.army[k].troop.currentLvl = t.troop.currentLvl;
          });
          _.forEach(backup.spells, function (t,k){
            self.spells[k].troop.currentUnits = t.troop.currentUnits;
            self.spells[k].troop.currentLvl = t.troop.currentLvl;
          });
          _.forEach(backup.barrks, function (t,k){
            self.barrks[k].barrk.maxSpace = t.barrk.maxSpace;
            self.barrks[k].barrk.level = t.barrk.level;
            self.barrks[k].barrk.boost = t.barrk.boost;
          });
          _.forEach(backup.spellFactories, function (t,k){
            self.spellFactories[k].barrk.maxSpace = t.barrk.maxSpace;
            self.spellFactories[k].barrk.level = t.barrk.level;
            self.spellFactories[k].barrk.boost = t.barrk.boost;
          });
          self.troopCapacity  = backup.troopCapacity;
          self.spellCapacity  = backup.spellCapacity;
        }
      }

      function reset(){
        _.forEach(self.army, function (t){
          t.troop.currentUnits = 0;
        });
        _.forEach(self.spells, function (t){
          t.troop.currentUnits = 0;
        });
      }

      function getLessTimeBarrack(barr, unit) {
          var freeId = -1;
          var trainTime = 99999;
          var unitBuildTime = unit.getBuildTime();
          //console.log(unitBuildTime);
          for (var i =0; i< barr.length; i++) {
              //console.log("Barrak "+i+" time :"+ barr[i].getTrainTime());
              //console.log(unit.getName(), barr[i].isBoost(), trainTime + '>' + ( barr[i].getTrainTime() + unitBuildTime ), barr[i].canTrain(unit.getName()) , barr[i].getSpace() + ' >= ' + unit.getSpace() );
              if( !barr[i].isBoost() && 
                  trainTime > barr[i].getTrainTime() + unitBuildTime && 
                  barr[i].canTrain(unit.getId()) &&  
                  barr[i].getSpace() >= unit.getSpace()
                ){
                  trainTime = barr[i].getTrainTime()+unitBuildTime ;
                  freeId = i;
              }
              // if Barrak is boosted
              
              if( 
                  barr[i].isBoost() && 
                  ( barr[i].getTrainTime()+ (unitBuildTime/4) ) < trainTime &&  
                  barr[i].canTrain(unit.getId()) &&
                  barr[i].getSpace() >= unit.getSpace()
                ){
                  //console.info("Selected "+i +" boosted for: "+ unit.getName());
                  //console.log("Se incadreaza la a 2-a");
                  trainTime = barr[i].getTrainTime()+unitBuildTime/4 ;
                  //trainTime = barr[i].getTrainTime();
                  freeId = i;
              }
              //console.log(trainTime,freeId );

          }
          //console.log(unit.getName()+ " goes to barrack "+ (freeId));
          //console.log(freeId, barr, unit);
          return freeId;
      }

      function addUnitsToBarracks(unit, barr){

          for(var j=0; j< unit.getCurrentUnits();j++){
              var barrId = getLessTimeBarrack(barr, unit);

              if(barrId != -1) {
                  if(barr[barrId].addTroopToTrain(unit) == -1){
                      console.log("Error in adding to barracks "+ barrId);
                      return;
                  }else{
                    // Unit added
                      //console.log("Added "+ unit.getName() + " to bID: "+(barrId) );
                  }
              }else{
                  console.log("Error in adding "+ unit.getName() +" to barracks...");
                  //alert("Could not add "+ unit.getName() +" to barracks...");
                  return;
              }
          }
      }




      $scope.$watch(angular.bind(this, function () {
        return this.army; // `this` IS the `this` above!!
      }), function (newVal, oldVal) {
        updateCosts()
        // now we will pickup changes to newVal and oldVal
      },true);
      $scope.$watch(angular.bind(this, function () {
        return this.spells; // `this` IS the `this` above!!
      }), function (newVal, oldVal) {
        updateCosts()
        // now we will pickup changes to newVal and oldVal
      },true);

      // RESTORE PREVIOS SESSION
      // var loadLastSession = JSON.parse(window.localStorage.troopCalcData);
      // window.test = loadLastSession;
      // angular.extend(self, loadLastSession);
      // console.log(loadLastSession);


  }

  TroopCtrl.resolve = {
    army : [
      'ArmyService','$stateParams',
      function(ArmyService,$stateParams) {
        return ArmyService.getArmy($stateParams.id)
          .then(function(response){
            return response.data;
          });
      }
    ]
  }

  angular
    .module('controllers.troop',['services.troop','services.army','services.troopBarrk'])

    .config(['$stateProvider', function ($stateProvider) {
      $stateProvider
        .state('app.troop', {
          cache: false,
          url: '/troop',
          views: {
              'content@app': {
                  controller: 'TroopCtrl as troop',
                  // create a instance so you can use the this keyWord
                  templateUrl: "templates/troopcalc/troopcalc.html",
                  resolve: TroopCtrl.resolve

              }
          },
          
          //resolve: TroopCtrl.resolve
          //authenticate: true,
          //onEnter: _onEnter,
          //onExit : _onExit
        })
    }])

    .controller('TroopCtrl', ['$state', 'TroopService','TroopBarrkService','army','$stateParams','$scope','$ionicScrollDelegate', TroopCtrl])
    .filter('barraktime', function() {
      return function(input) {
        var hour = parseInt(input / 3600);
        var min = parseInt((input - hour*3600) / 60);
        var sec = parseInt(input % 60);
        var ret = '';

        if(hour) {
          //ret = ret + hour + "h "
          ret = hour+":";
        }

        if(min < 10) {
          ret = ret + "0";
        }
        ret = ret+min+":";
        if(sec < 10) {
          ret = ret + "0";
        }
        ret = ret+sec;

        return ret;
      };
    });
})();
