(function(){
	'use strict';

	var TroopFact = function(troopData) {
			this.troop = {};
			this.troop.name = troopData[0]; 
			this.troop.space = troopData[1]; 
			this.troop.isSpell = troopData[2];
			this.troop.elixir = troopData[3]; 
			this.troop.buildTime = troopData[4]; 
			this.troop.maxLvl = troopData[5]; 
			this.troop.currentLvl = troopData[6];
			this.troop.levels = troopData[7];
			this.troop.id = troopData[8];
			this.troop.currentUnits = 0;

    	
			//console.log(name,space);

		};

		TroopFact.prototype.setLevels = function(levels){
				this.troop.levels = levels;
		};

		TroopFact.prototype.getName = function() {
				return this.troop.name;
		};

		TroopFact.prototype.getId = function() {
				return this.troop.id;
		};

		TroopFact.prototype.getSpace = function() {
				return this.troop.space;
		};

		TroopFact.prototype.getIsSpell = function() {
				return this.troop.isSpell;
		};

		TroopFact.prototype.isElixir = function() {
				return this.troop.elixir;
		};

		TroopFact.prototype.getBuildTime = function() {
				return this.troop.buildTime;
		};

		TroopFact.prototype.getMaxLvl = function() {
				return this.troop.maxLvl;
		};


		TroopFact.prototype.setCurrentLvl = function(currentLvl) {
				this.troop.currentLvl = this.troop.currentLvl;
		};

		TroopFact.prototype.getCurrentUnits = function() {
				return this.troop.currentUnits;
		};

		TroopFact.prototype.setCurrentUnits = function(currentUnits) {
				this.troop.currentUnits = this.troop.currentUnits;
		};

		TroopFact.prototype.getTroopCost = function(){
				return this.troop.levels[this.troop.currentLvl];
		};

		TroopFact.prototype.getTotalTroopsCost = function(){
				return this.troop.levels[this.troop.currentLvl] * this.troop.currentUnits;
				
		};

		TroopFact.prototype.getTotalTroopsTime = function(){
				return this.troop.buildTime * this.troop.currentUnits;
		};

		TroopFact.prototype.getTotalTroopsSpace = function(){
				return this.troop.space * this.troop.currentUnits;
		};


	angular
		.module('services.troop',[])
		.factory('TroopService',[
			'$injector',
			function ($injector) {
    			return function(troopData) { 
    				return $injector.instantiate(TroopFact, { troopData: troopData }); 
    			};
			}
		]);


})();

