'use strict';

/*
 * controllers/profile/main.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.videos', [])

    .controller('VideosCtrl', [
        '$http',
        '$q',
        '$ionicLoading',
        '$scope',
        '$rootScope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        '$sce',
        function($http,$q, $ionicLoading,  $scope, $rootScope, $state, $stateParams, Constants, AuthService,$sce) {
            //show loading gif
            $ionicLoading.show({
                template: 'Loading...'
            });

            if(Constants.DEBUGMODE){
                console.log("videos controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";

            if(typeof analytics !== 'undefined'){
                analytics.trackView("Video Page");
            }
            $scope.search = {value:''}
            $scope.videos = [];
            $scope.gotovideo = gotovideo;
            $scope.selectTag = selectTag;
            $scope.appVersion = appVersion;

            $scope.toDate = function(dateString) {
                return new Date(dateString);
            }
            if($stateParams.id){
                $scope.videoId = $sce.trustAsResourceUrl("http://www.youtube.com/embed/"+$stateParams.id);;
            } 
            else{
            
                $scope.getVideos = function(){
                    var deferred = $q.defer();
                    $ionicLoading.show({
                        template: 'Loading war stats...'
                    });

                    var success = function(response, status, headers, config){
                        $scope.videos= response;
                        _.each($scope.videos, function(v){
                            v.tags= _.map(v.tags,'name');
                        });
                        $ionicLoading.hide();
                        deferred.resolve(response.payload);
                    }

                    // error callback
                    var error = function(error, status, headers, config){
                        $scope.title= error.message;
                        $ionicLoading.hide();

                        deferred.reject(error);
                    }
                    $scope.user = AuthService.currentUser.info;
                    $http.get(Constants.API.baseUrl+'/videos').success(success).error(error).finally(function() {
                        // Stop the ion-refresher from spinning
                        $scope.$broadcast('scroll.refreshComplete');
                    });

                    return deferred.promise;

                }();
            }
            
            function gotovideo(video){
                $rootScope.video = video;
                $state.go("app.videos.video", {id:video.video_id}, {inherit:false});
            }
            function selectTag(tag) {
                $scope.search.value = tag;
            }

            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });

            $ionicLoading.hide();
        }]);