'use strict';

angular.module('controllers.war.suggest', ['services.models.army'])
.controller('SuggestCtrl',['$scope','ArmyModel','$stateParams','$state','$q','$http','$ionicLoading','$ionicPopup','$timeout',function($scope, ArmyModel,$stateParams,$state,$q,$http,$ionicLoading,$ionicPopup,$timeout) {
        $scope.Math = window.Math;
        console.log();
    $scope.data = function(){
        ArmyModel.async($stateParams.id).then(function () {
          $timeout(function(){
            $scope.member = ArmyModel.data();
            $scope.maxArmy = $scope.member.maxArmy;
            $scope.maxSpells = $scope.member.maxSpells;
            $scope.troops = [];
            $scope.spells = [];
            $scope.notes = '';
            $scope.img = null;

            angular.forEach($scope.member.army, function (troop, key) {

                $scope.troops.push({
                    id: troop.id,
                    value: 0,
                    name: troop.name,
                    housing: troop.housing,
                    max: troop.housing > 0 ? $scope.Math.floor($scope.maxArmy / troop.housing) : 1,
                    lvl: troop.pivot.lvl
                });
            });
            angular.forEach($scope.member.spells, function (spell, key) {
                $scope.spells.push({
                    id: spell.id,
                    value: 0,
                    name: spell.name,
                    housing: spell.housing,
                    max: spell.housing ? $scope.Math.floor($scope.maxSpells / spell.housing) : 1,
                    lvl: spell.pivot.lvl
                });
            });

            $scope.castle = $scope.member.castle;
			$timeout(function(){
				console.log(1000);
				$scope.$apply();
			},500);
			
            $scope.$broadcast('scroll.refreshComplete');

            $scope.plusone = function (val) {
                if (val.value < val.max) {
                    val.value = parseInt(val.value) + 1;
                }
                $scope.getMax();
                return true;
            }

            $scope.minusone = function (val) {
                if (val.value > 0) {
                    val.value = parseInt(val.value) - 1;
                }
                $scope.getMax();
                return true;
            }

            $scope.sum = function (list) {
                var total = 0;
                angular.forEach(list, function (item) {
                    total += parseInt(item.value);
                });
                return total;
            }
            $scope.getTotal = function () {
                var total = 0;
                for (var i = 0; i < $scope.troops.length; i++) {
                    var product = $scope.troops[i];
                    total += (product.value * product.housing);
                }
                return total;
            }

            $scope.getTotalSpells = function () {
                var total = 0;
                for (var i = 0; i < $scope.spells.length; i++) {
                    var product = $scope.spells[i];
                    total += (product.value * product.housing);
                }
                return total;
            }

            $scope.getMax = function () {
                var $this = this;
                var current = $scope.getTotal();
                var currentS = $scope.getTotalSpells();
                var free = $scope.maxArmy - current;
                var freeSpell = $scope.maxSpells - currentS;
                angular.forEach($scope.troops, function (troop, key) {
                    if (troop.housing != 0) {
                        troop.max = $scope.Math.floor(free / troop.housing) + parseInt(troop.value);
                    }
                });

                angular.forEach($scope.spells, function (spell, key) {
                    if (spell.housing != 0) {
                        spell.max = $scope.Math.floor(freeSpell / spell.housing) + parseInt(spell.value);
                    }
                });

                return true;
            }


            /* Select image from phone */
            $scope.GetImg = function () {
                $cordovaCamera.getPicture(onSuccess, onFail, {
                    quality: 90,
                    destinationType: Camera.DestinationType.FILE_URI,
                    sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                    encodingType: Camera.EncodingType.JPEG,
                    mediaType: Camera.MediaType.PICTURE,
                    targetWidth: 960,
                    targetHeight: 720

                });

                function onSuccess(imageData) {
                    //var image = document.getElementById('myImage'.player);
                    //image.src = imageData;
                    $ionicLoading.show({
                        template: "Uploading Image"
                    });
                    $scope.UploadImg(imageData);
                }

                function onFail(message) {
                    alert('Failed because: ' + message);
                }
            };

            /* Upload image to server */
            $scope.UploadImg = function (imageData) {
                var ft = new FileTransfer();
                var options = new FileUploadOptions();
                var serverUrl = "http://clashofclanswarplan.com/en/api/upload/";
                options.fileKey = 'file';
                options.fileName = imageData.substr(imageData.lastIndexOf('/') + 1);
                options.mimeType = "image/jpeg";
                //options.params =
                options.headers = {'X-Access-Token': window.localStorage.getItem('sessionToken') || ""}
                ft.upload(imageData, serverUrl, onUploadSuccess, onUploadError, options);

                function onUploadSuccess(data) {
                    if (typeof analytics !== 'undefined') {
                        analytics.trackEvent('War', 'Upload Suggest Img');
                    }

                    $ionicLoading.hide();
                    var imgData = JSON.parse(data.response);
                    $ionicPopup.alert({
                        title: 'Done',
                        template: "Image uploaded "
                    });
                    $scope.modal.hide();

                    $scope.img = imgData.file;
                }

                function onUploadError(error) {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: 'Error',
                        template: "There was an error uploading the image."
                    });
                }
            };

            $scope.submit = function () {
                var self = this;
                var form = {};
                form.army = {};
                angular.forEach($scope.troops, function (t) {
                    //if(t.value > 0){
                    form.army[t.id] = t.value;
                    //}
                });
                form.spells = {};
                angular.forEach($scope.spells, function (t) {
                    //if(t.value > 0){
                    form.spells[t.id] = t.value;
                    //}
                });
                form.notes = self.notes;
                form.img = self.img;
                form.reserveId = $stateParams.id;
                form.playerNr = $scope.member.enemyId;
                ArmyModel.submit(form).then(function () {
                    var result = ArmyModel.submitResult();
                    if (result.ok) {
                        if (typeof analytics !== 'undefined') {
                            analytics.trackEvent('War', 'Submit Suggestion');
                        }
                        $ionicPopup.alert({
                            title: 'Done',
                            template: result.ok.message
                        }).then(function () {
                            $state.go("app.war.suggest.view", {id: result.ok.id});
                        });

                    } else {
                        $ionicPopup.alert({
                            title: 'Error',
                            template: result.error.message
                        })
                    }

                });



                //console.info(angular.toJson(form));
            }
            

        },2000);
        });
    }
    $scope.data();

}]);


/*   --------------> SUGGEST VIEW <------------------- */

angular.module('controllers.war.suggest.view', ['services.models.army'])
    .controller('SuggestViewCtrl',['$scope','ArmyModel','$stateParams','$q','$http','$ionicLoading','$ionicPopup','$timeout',function($scope, ArmyModel,$stateParams,$q,$http,$ionicLoading,$ionicPopup,$timeout){

        $scope.Math = window.Math;
        $scope.data = function(){
            ArmyModel.asyncview($stateParams.id).then(function() {
                $scope.member = ArmyModel.viewdata();
                $scope.s = $scope.member.data;
                $scope.maxArmy = $scope.member.maxArmy;
                $scope.maxSpells = $scope.member.maxSpells;
                $scope.troops = [];
                $scope.spells = [];
                $scope.notes = '';
                $scope.img = null;
                angular.forEach($scope.member.army ,function(troop,key){
                    $scope.troops.push({id:troop.id,value: 0, name: troop.name, housing: troop.housing, max: troop.housing > 0 ? $scope.Math.floor($scope.maxArmy / troop.housing) : 1, lvl : troop.pivot.lvl});
                });

                angular.forEach($scope.member.spells ,function(spell,key){
                    $scope.spells.push({id: spell.id ,value: 0,name: spell.name, housing: spell.housing, max: spell.housing ? $scope.Math.floor($scope.maxSpells / spell.housing) : 1, lvl : spell.pivot.lvl});
                });

                $scope.castle = $scope.member.castle;
                $scope.$broadcast('scroll.refreshComplete');
				$timeout(function(){
					console.log($scope.troops);
					$scope.$apply();
				},1000);



            });

        }

        $scope.data();

    }]);