(function(){
	'use strict';

	var WarService = function($http, $q, Constants,$cordovaCamera){

		this.getData = function(){
        var deferred = $q.defer();

        var success = function(response, status, headers, config){
            // $scope.enemies = response.payload.enemies;
            // $scope.war = response.payload.war;
            // $scope.title=$scope.war.name;
            // $ionicLoading.hide();
            deferred.resolve(response.payload);
        }

        // error callback
        var error = function(error, status, headers, config){
            // $scope.title= error.message;
            // $ionicLoading.hide();
            // $scope.$destroy();
            // AuthService.logout().then(function(){$state.go("app.auth")});
            // return $state.go("app.auth");

            deferred.reject(error);
        }
        $http.get(Constants.API.baseUrl+'/war').success(success).error(error).finally(function() {
            // Stop the ion-refresher from spinning
            // $scope.$broadcast('scroll.refreshComplete');
        });

        return deferred.promise;

    }

    this.startWar = function(){
        if(Constants.DEBUGMODE){
            console.log("Start war");
        }
        if(typeof analytics !== 'undefined'){
            analytics.trackEvent('War', 'Start');
        }




        var deferred = $q.defer();

        var success = function(response, status, headers, config){
            $scope.data();
            $scope.closeEdit(2);
            $scope.closeEdit(1);

            //$scope.closeEdit();
            //$state.go('app.clan');
            deferred.resolve(response.payload);
        }

        // error callback
        var error = function(error, status, headers, config){
            $ionicPopup.alert({
                title: 'Problem',
                template: error.message
            });


            deferred.reject(error);
        }

        $http.post(Constants.API.baseUrl+'/war/start', $scope.war).success(success).error(error);

        return deferred.promise;

    }

    this.endWar = function(forceDel,score){
        if(!score) return false;

        //return console.log(score);
        if(Constants.DEBUGMODE){
            console.log("Stop war");
        }
        if(typeof analytics !== 'undefined'){
            analytics.trackEvent('War', 'End');
        }
        //$scope.showPopup.close();

        var deferred = $q.defer();

        var success = function(response, status, headers, config){
            $scope.data();
            $scope.closeEdit(1);
            $scope.closeEdit(2);
            //$state.go('app.clan');
            deferred.resolve(response.payload);
        }

        // error callback
        var error = function(error, status, headers, config){
            console.log(error);
            $ionicPopup.alert({
                title: 'Problem',

                template: error.message
            });


            deferred.reject(error);
        }

        $http.post(Constants.API.baseUrl+'/war/end', {force: forceDel,score: score }).success(success).error(error);

        return deferred.promise;

    }

    this.GetImg = function(player){
        $cordovaCamera.getPicture(onSuccess, onFail, {
            quality: 90,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType : Camera.PictureSourceType.PHOTOLIBRARY,
            encodingType: Camera.EncodingType.JPEG,
            mediaType: Camera.MediaType.PICTURE,
            targetWidth: 960,
            targetHeight:   720

        });

        function onSuccess(imageData) {
            //var image = document.getElementById('myImage'.player);
            //image.src = imageData;
            $ionicLoading.show({
                template: "Uploading Image"
            });
            this.UploadImg(imageData,player);
        }

        function onFail(message) {
            alert('Failed because: ' + message);
        }
    };

    /* Upload image to server */
    this.UploadImg = function(imageData,player){
        var ft = new FileTransfer();
        var options = new FileUploadOptions();
        var serverUrl = "http://clashofclanswarplan.com/en/api/upload/" + player;
        options.fileKey  = 'file';
        options.fileName = imageData.substr(imageData.lastIndexOf('/')+1);
        options.mimeType = "image/jpeg";
        //options.params =
        options.headers = {'X-Access-Token': window.localStorage.getItem('sessionToken') || ""}
        ft.upload(imageData, serverUrl, onUploadSuccess, onUploadError, options);

        function onUploadSuccess(){
            if(typeof analytics !== 'undefined'){
                analytics.trackEvent('War', 'Image Uploaded');
            }

            $ionicLoading.hide();
            $ionicPopup.alert({
                title: 'Done',
                template: "Image uploaded"
            });
            $scope.modal.hide();
            $scope.data();
        }

        function onUploadError(){
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: 'Error',
                template: "There was an error uploading the image."
            });
        }
    };

    this.DelImg = function(id){
        if(Constants.DEBUGMODE){
            console.log("Start war");
        }
        if(typeof analytics !== 'undefined'){
            analytics.trackEvent('War', 'ImgDel');
        }




        var deferred = $q.defer();

        var success = function(response, status, headers, config){
            // $scope.data();
            // $scope.closeEdit(2);
            // $scope.closeEdit(1);

            //$scope.closeEdit();
            //$state.go('app.clan');
            deferred.resolve(response.payload);
        }

        // error callback
        var error = function(error, status, headers, config){
            // $ionicPopup.alert({
            //     title: 'Problem',
            //     template: error.message
            // });


            deferred.reject(error);
        }

        $http.post(Constants.API.baseUrl+'/war/imgdel/'+id, {}).success(success).error(error);

        return deferred.promise;

    }

    this.resetWar = function(){

        return {   start: $scope.warSettings.start[24],
            reserve_max: $scope.warSettings.reserve_max[2],
            asize:$scope.warSettings.asize[1],
            reserve_time:$scope.warSettings.reserve_time[0],
            reserve_time2:$scope.warSettings.reserve_time2[0],
            reserve_3star:$scope.warSettings.reserve_3star[0],
            reserve_after_star:$scope.warSettings.reserve_after_star[1],
            hasImg:$scope.warSettings.hasImg[0]
        };
    }


	}

	angular
		.module('services.war',['ngCordova.plugins.camera'])
		.service('WarService',[
			'$http',
			'$q',
			'Constants',
			'$cordovaCamera',
			WarService]);


})();