'use strict';

/*
 * controllers/profile/main.js
 * controller for the profile page
 *
 * (c) 2014 Vincent Maliko http://frnchnrd.com
 * License: MIT
 */

angular.module('controllers.war.archive.info', ['ngCordova.plugins.camera'])

    .controller('WarArchiveInfoCtrl', [
        '$http',
        '$q',
        '$cordovaCamera',
        '$ionicActionSheet',
        '$ionicModal',
        '$ionicLoading',
        '$ionicPopup',
        '$timeout',
        '$scope',
        '$state',
        '$stateParams',
        'Constants',
        'AuthService',
        function($http,$q,$cordovaCamera, $ionicActionSheet, $ionicModal, $ionicLoading, $ionicPopup, $timeout, $scope,$state, $stateParams, Constants, AuthService) {
            //show loading gif
            // $ionicLoading.show({
            //     template: 'Loading clan...'
            // });

            if(Constants.DEBUGMODE){
                console.log("WarStats controller");
                console.log($stateParams);
            }
            $http.defaults.headers.common['X-Access-Token'] = window.localStorage.getItem('sessionToken') || "";

            if(typeof analytics !== 'undefined'){
                analytics.trackView("War Archive Info");
            }

            $scope.id= $stateParams.id;
            
            $scope.data = function(){
                var deferred = $q.defer();
                $ionicLoading.show({
                    template: 'Loading war stats...'
                });

                var success = function(response, status, headers, config){
                    $scope.stats = response.payload;
                    
                    $ionicLoading.hide();
                    deferred.resolve(response.payload);
                }

                // error callback
                var error = function(error, status, headers, config){
                    $scope.title= error.message;
                    $ionicLoading.hide();
                    //$scope.$destroy();
                    //AuthService.logout().then(function(){$state.go("app.auth")});
                    //return $state.go("app.auth");

                    deferred.reject(error);
                }
                $scope.user = AuthService.currentUser.info;
                $http.get(Constants.API.baseUrl+'/war/archive/info/'+$scope.id).success(success).error(error).finally(function() {
                    // Stop the ion-refresher from spinning
                    $scope.$broadcast('scroll.refreshComplete');
                });

                return deferred.promise;

            }
            $scope.data();

            $ionicModal.fromTemplateUrl('my-modal.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function(modal) {
              $scope.modal = modal;
            });

            $scope.openModal = function() {
              $scope.stat = this.stat;
              $scope.modal.show();
            };
            $scope.closeModal = function() {
              $scope.modal.hide();
            };
            //Cleanup the modal when we're done with it!
            $scope.$on('$destroy', function() {
              $scope.modal.remove();
            });
            // Execute action on hide modal
            $scope.$on('modal.hidden', function() {
              // Execute action
            });
            // Execute action on remove modal
            $scope.$on('modal.removed', function() {
              // Execute action
            });


            $scope.$on("$destroy", function() {
                if(Constants.DEBUGMODE){
                    console.log('destroying ProfileCtrl');
                }


            });

            // $ionicLoading.hide();
        }]);